"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const Button_1 = __importDefault(require("../Button/Button"));
const Text_1 = __importDefault(require("../Text/Text"));
const ThemeContext_1 = __importDefault(require("../ThemeContext/ThemeContext"));
const colors_1 = require("../UikitUtils/colors");
const themeHelper_1 = require("../UikitUtils/themeHelper");
const styles = react_native_1.StyleSheet.create({
    containerStyle: {
        borderRadius: 4,
        paddingVertical: 8,
        paddingHorizontal: 8,
        display: 'flex',
        alignItems: 'center',
        justifyContent: 'center',
    },
    textStyle: {
        fontSize: 12,
    },
});
const defaultProps = {
    type: 'primary',
};
const Badge = ({ type, children, onClick, disabled }) => {
    const { theme } = (0, react_1.useContext)(ThemeContext_1.default);
    let backgroundColor;
    let textColor = 'white';
    if (type === 'primary') {
        backgroundColor = (0, themeHelper_1.primaryColor)(theme);
        textColor = 'white';
    }
    else if (type === 'secondary') {
        backgroundColor = (0, themeHelper_1.secondaryColor)(theme);
        textColor = 'white';
    }
    else if (type === 'success') {
        backgroundColor = colors_1.SEMANTIC_SUCCESS_GREEN_PRIMARY;
        textColor = 'white';
    }
    if (type === 'error') {
        backgroundColor = colors_1.SEMANTIC_RED_PRIMARY;
        textColor = 'white';
    }
    return (react_1.default.createElement(Button_1.default, { disabled: disabled, onClick: onClick, type: "link" },
        react_1.default.createElement(react_native_1.View, { style: [styles.containerStyle, { backgroundColor }] },
            react_1.default.createElement(Text_1.default, { color: textColor, overrideStyle: [styles.textStyle] }, children))));
};
Badge.defaultProps = defaultProps;
exports.default = Badge;
