/// <reference types="react" />
import { ViewStyle } from 'react-native';
import { OverrideStyle } from '../Flex/Flex';
export type ButtonType = 'primary' | 'secondary' | 'link' | 'success' | 'tertiary';
export declare const isButtonTypeKey: (str: string | undefined) => str is ButtonType;
export declare const isOverrideStyleArray: (str: OverrideStyle | undefined) => str is ViewStyle[];
declare const defaultProps: {
    type: string;
    textSize: number;
};
type Props = {
    children: import('react').ReactChild;
    flex?: number;
    overrideStyle?: ViewStyle[] | ViewStyle;
    onClick?: (arg: any) => void;
    flat?: boolean;
    curved?: boolean;
    disabled?: boolean;
    testID?: string;
    loading?: boolean;
    contain?: boolean;
    type: ButtonType;
} & typeof defaultProps;
declare const Button: {
    ({ flat, overrideStyle, onClick, children, curved, disabled, flex, testID, loading, contain, textSize, type, }: Props): JSX.Element;
    defaultProps: {
        type: string;
        textSize: number;
    };
};
export default Button;
