"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Playground = exports.Basic = void 0;
const react_1 = __importDefault(require("react"));
const react_native_1 = require("react-native");
const addon_actions_1 = require("@storybook/addon-actions");
const Button_1 = __importDefault(require("./Button"));
const storiesHelper_1 = require("../UikitUtils/storiesHelper");
const Flex_1 = __importDefault(require("../Flex/Flex"));
const constants_1 = require("../UikitUtils/constants");
const colors_1 = require("../UikitUtils/colors");
const { height } = react_native_1.Dimensions.get('window');
const Basic = () => {
    return (react_1.default.createElement(react_native_1.ScrollView, { style: { height, backgroundColor: colors_1.GRAY_95 } },
        react_1.default.createElement(Flex_1.default, { overrideStyle: { paddingTop: 30, paddingBottom: 20 } },
            react_1.default.createElement(storiesHelper_1.ButtonComponent, { label: "Primary Button" },
                react_1.default.createElement(Button_1.default, { onClick: (0, addon_actions_1.action)('clicked-primary') }, "Primary Button")),
            react_1.default.createElement(storiesHelper_1.ButtonComponent, { label: "Primary Button Disabled" },
                react_1.default.createElement(Button_1.default, { disabled: true, onClick: (0, addon_actions_1.action)('clicked-primary-disabled') }, "Primary Button Disabled")),
            react_1.default.createElement(storiesHelper_1.ButtonComponent, { label: "Secondary Button" },
                react_1.default.createElement(Button_1.default, { type: "secondary", onClick: (0, addon_actions_1.action)('clicked-Secondary') }, "Secondary Button")),
            react_1.default.createElement(storiesHelper_1.ButtonComponent, { label: "Secondary Button Disabled" },
                react_1.default.createElement(Button_1.default, { type: "secondary", disabled: true, onClick: (0, addon_actions_1.action)('clicked-Secondary-disabled') }, "Secondary Button Disabled")),
            react_1.default.createElement(storiesHelper_1.ButtonComponent, { label: "Success Button" },
                react_1.default.createElement(Button_1.default, { type: "success", onClick: (0, addon_actions_1.action)('clicked-success') }, "Success Button")),
            react_1.default.createElement(storiesHelper_1.ButtonComponent, { label: "Success Button Disabled" },
                react_1.default.createElement(Button_1.default, { type: "success", disabled: true, onClick: (0, addon_actions_1.action)('clicked-success-disabled') }, "Success Button Disabled")),
            react_1.default.createElement(storiesHelper_1.ButtonComponent, { label: "Tertiary Button" },
                react_1.default.createElement(Button_1.default, { type: "tertiary", onClick: (0, addon_actions_1.action)('clicked-tertiary') }, "Tertiary Button")),
            react_1.default.createElement(storiesHelper_1.ButtonComponent, { label: "Tertiary Button Disabled" },
                react_1.default.createElement(Button_1.default, { type: "tertiary", disabled: true, onClick: (0, addon_actions_1.action)('clicked-tertiary-disabled') }, "Tertiary Button Disabled")),
            react_1.default.createElement(storiesHelper_1.ButtonComponent, { label: "Loading Button Button" },
                react_1.default.createElement(Button_1.default, { loading: true, onClick: (0, addon_actions_1.action)('clicked-Loading') }, "Loading Button")),
            react_1.default.createElement(storiesHelper_1.ButtonComponent, { label: "Loading Button Disabled" },
                react_1.default.createElement(Button_1.default, { loading: true, disabled: true, onClick: (0, addon_actions_1.action)('clicked-Loading-disabled') }, "Loading Button Disabled")),
            react_1.default.createElement(storiesHelper_1.ButtonComponent, { label: "Flat Button Button" },
                react_1.default.createElement(Button_1.default, { flat: true, onClick: (0, addon_actions_1.action)('clicked-Flat') }, "Flat Button")),
            react_1.default.createElement(storiesHelper_1.ButtonComponent, { label: "Flat Button Disabled" },
                react_1.default.createElement(Button_1.default, { flat: true, disabled: true, onClick: (0, addon_actions_1.action)('clicked-Flat-disabled') }, "Flat Button Disabled")),
            react_1.default.createElement(storiesHelper_1.ButtonComponent, { label: "Link Button Button" },
                react_1.default.createElement(Button_1.default, { type: "link", onClick: (0, addon_actions_1.action)('clicked-Link') }, "Link Button")),
            react_1.default.createElement(storiesHelper_1.ButtonComponent, { label: "Link Button Disabled" },
                react_1.default.createElement(Button_1.default, { type: "link", disabled: true, onClick: (0, addon_actions_1.action)('clicked-Link-disabled') }, "Link Button Disabled")))));
};
exports.Basic = Basic;
const Template = args => (react_1.default.createElement(Button_1.default, { ...args }, "Text with dynamic size attribute"));
exports.Playground = Template.bind({});
exports.default = {
    title: `${constants_1.STORIES_PREFIX.components}/Button`,
    component: Button_1.default,
};
