/// <reference types="react" />
import type { DateObject } from 'react-native-calendars';
type ViewStyle = import('react-native').ViewStyle;
type PartialDateObj = {
    day: number;
    month: number;
    year: number;
};
export type InititalDateType = DateObject | undefined;
export type CommonProps = {
    onChange: (arg: string) => void;
    minDate?: string;
    scrollable?: boolean;
};
export type CommonDefaultProps = {
    align: 'bottomLeft' | 'topLeft' | 'topRight';
};
export type DefaultProps = {
    maxDate: string;
};
type Props = {
    selectedDateColor?: string;
    showTime?: boolean;
    value?: string;
    initialHour?: string;
    initialMinute?: string;
    overrideStyle?: ViewStyle;
    placeholder?: string;
    disabled?: boolean;
} & CommonProps & DefaultProps & CommonDefaultProps;
export declare const getDay: (day: number) => string;
export declare const getMonth: (month: number) => string;
export declare const getRequiredPartialDateObj: (date: InititalDateType) => {
    day: number;
    month: number;
    year: number;
};
export declare const getDateString: (date: PartialDateObj) => string;
export declare const handleCurrentDate: (date: Date) => DateObject;
export declare const getAbsoluteTime: (time: number) => string;
export declare const convertDateStrtoDateObject: (datestring: string | undefined) => InititalDateType;
declare const Calendar: {
    ({ selectedDateColor, showTime, value, initialHour, initialMinute, onChange, maxDate, overrideStyle, placeholder, disabled, minDate, align, scrollable, }: Props): JSX.Element;
    defaultProps: DefaultProps & CommonDefaultProps;
};
export default Calendar;
