"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.convertDateStrtoDateObject = exports.getAbsoluteTime = exports.handleCurrentDate = exports.getDateString = exports.getRequiredPartialDateObj = exports.getMonth = exports.getDay = void 0;
/* eslint-env browser */
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const Flex_1 = __importDefault(require("../Flex/Flex"));
const SvgCalendar_1 = __importDefault(require("../icons/SvgCalendar"));
const Text_1 = __importDefault(require("../Text/Text"));
const colors_1 = require("../UikitUtils/colors");
const helpers_1 = require("../UikitUtils/helpers");
const CalendarList_1 = __importDefault(require("./CalendarList"));
const Month_1 = __importDefault(require("./Month"));
const Year_1 = __importDefault(require("./Year"));
const validators_1 = require("../UikitUtils/validators");
const ThemeContext_1 = __importDefault(require("../ThemeContext/ThemeContext"));
const ClickOutsideHook_1 = require("./ClickOutsideHook");
const styles = react_native_1.StyleSheet.create({
    border: {
        borderWidth: 1,
        backgroundColor: colors_1.WHITE,
        borderColor: colors_1.BORDER_COLOR,
        alignItems: 'stretch',
        paddingHorizontal: 12,
        width: '100%',
        paddingVertical: 10,
        borderRadius: 4,
        height: 40,
    },
    time: {
        padding: 16,
    },
    calendar: {
        borderWidth: 1,
        borderColor: colors_1.BORDER_COLOR,
        borderRadius: 4,
    },
    content: {
        paddingHorizontal: 32,
        paddingBottom: 6,
    },
    relative: {
        position: 'relative',
    },
    disabled: {
        backgroundColor: colors_1.GRAY_95,
    },
});
const defaultProps = {
    maxDate: '9999-12-31',
    align: 'topLeft',
};
const CURRENT_DATE = new Date();
const getDay = (day) => (day < 10 ? `0${day}` : `${day}`);
exports.getDay = getDay;
const getMonth = (month) => month < 10 ? `0${month}` : `${month}`;
exports.getMonth = getMonth;
const getRequiredPartialDateObj = (date) => {
    if (date) {
        return {
            day: date.day,
            month: date.month,
            year: date.year,
        };
    }
    return {
        day: CURRENT_DATE.getDate(),
        month: CURRENT_DATE.getMonth() + 1,
        year: CURRENT_DATE.getFullYear(),
    };
};
exports.getRequiredPartialDateObj = getRequiredPartialDateObj;
const getReadableDate = (date) => {
    if (!date)
        return '';
    const day = (0, exports.getDay)(date.day);
    const month = (0, exports.getMonth)(date.month);
    return `${day}/${month}/${date.year}`;
};
const getDateString = (date) => `${date.year}-${(0, exports.getMonth)(date.month)}-${(0, exports.getDay)(date.day)}`;
exports.getDateString = getDateString;
const handleCurrentDate = (date) => {
    const day = date.getDate();
    const month = date.getMonth() + 1;
    const year = date.getFullYear();
    const timestamp = Date.now();
    const dateString = (0, exports.getDateString)({ day, month, year });
    return {
        day,
        month,
        year,
        timestamp,
        dateString,
    };
};
exports.handleCurrentDate = handleCurrentDate;
const getAbsoluteTime = (time) => {
    let result = '';
    if (time < 10) {
        result = `0${time}`;
    }
    else {
        result = `${time}`;
    }
    return result;
};
exports.getAbsoluteTime = getAbsoluteTime;
const convertDateStrtoDateObject = (datestring) => {
    if (!datestring) {
        return undefined;
    }
    if (!(0, helpers_1.isValidDate)(datestring)) {
        return undefined;
    }
    const parsedDate = new Date(datestring);
    return (0, exports.handleCurrentDate)(parsedDate);
};
exports.convertDateStrtoDateObject = convertDateStrtoDateObject;
const Calendar = ({ selectedDateColor = 'red', showTime = false, value, initialHour = '', initialMinute = '', onChange, maxDate, overrideStyle, placeholder, disabled, minDate, align, scrollable, }) => {
    const [open, setOpen] = (0, react_1.useState)({
        date: false,
        month: false,
        year: false,
    });
    (0, react_1.useEffect)(() => {
        const requiredDate = (0, exports.convertDateStrtoDateObject)(value);
        setDate(requiredDate);
    }, [value]);
    const initialDate = (0, exports.convertDateStrtoDateObject)(value);
    const [date, setDate] = (0, react_1.useState)(initialDate);
    const [hour, setHour] = (0, react_1.useState)(initialHour);
    const [min, setMin] = (0, react_1.useState)(initialMinute);
    const Ref = (0, react_1.useRef)();
    const themeContext = (0, react_1.useContext)(ThemeContext_1.default);
    const parentClicked = themeContext.parentClicked
        ? themeContext.parentClicked
        : false;
    (0, react_1.useEffect)(() => {
        if (parentClicked && open) {
            setOpen({
                date: false,
                month: false,
                year: false,
            });
        }
    }, [parentClicked]);
    const handleClickOutside = (e) => {
        if (Ref.current && !Ref.current.contains(e.target)) {
            handleDateClose();
        }
    };
    (0, ClickOutsideHook_1.useClickOutsideWeb)({
        handleClick: handleClickOutside,
    });
    const dateInputStyle = (0, react_1.useMemo)(() => {
        const styleArray = [styles.border];
        if (overrideStyle) {
            styleArray.push(overrideStyle);
        }
        if (disabled) {
            styleArray.push(styles.disabled);
        }
        return react_native_1.StyleSheet.flatten(styleArray);
    }, [disabled]);
    const handleDateOpen = (e) => {
        if (e) {
            e.stopPropagation();
        }
        if (themeContext.setParentClicked) {
            themeContext.setParentClicked(false);
        }
        setOpen({
            date: true,
            month: false,
            year: false,
        });
    };
    const handleDateClose = () => setOpen({
        date: false,
        month: false,
        year: false,
    });
    const handleOpenMonth = (e) => {
        e.stopPropagation();
        if (themeContext.setParentClicked) {
            themeContext.setParentClicked(false);
        }
        setOpen({
            date: false,
            month: true,
            year: false,
        });
    };
    const handleCloseMonth = (e) => {
        e.stopPropagation();
        setOpen({
            date: true,
            month: false,
            year: false,
        });
    };
    const handleSelectMonth = (e, month) => {
        e.stopPropagation();
        const requiredMonth = month + 1;
        const requiredObject = (0, exports.getRequiredPartialDateObj)(date);
        const dateString = (0, exports.getDateString)({
            ...requiredObject,
            month: requiredMonth,
        });
        const dateObject = (0, exports.convertDateStrtoDateObject)(dateString);
        setDate(dateObject);
        handleCloseMonth(e);
    };
    const handleOpenYear = (e) => {
        e.stopPropagation();
        setOpen({
            date: false,
            month: false,
            year: true,
        });
    };
    const handleCloseYear = (e) => {
        handleOpenMonth(e);
    };
    let HOUR = '';
    let meridiem = '';
    if (hour) {
        let parsedHour = parseInt(hour, 10);
        if (parsedHour === 12) {
            HOUR = ` | ${(0, exports.getAbsoluteTime)(parsedHour)}`;
            meridiem = 'pm';
        }
        else if (parsedHour > 12) {
            parsedHour -= 12;
            HOUR = ` | ${(0, exports.getAbsoluteTime)(parsedHour)}`;
            meridiem = 'pm';
        }
        else {
            HOUR = ` | ${(0, exports.getAbsoluteTime)(parsedHour)}`;
            meridiem = 'am';
        }
    }
    const MIN = min ? `: ${min}` : '';
    const formattedDate = getReadableDate(date);
    const memoizedValue = (0, react_1.useMemo)(() => formattedDate + HOUR + MIN + meridiem, [
        formattedDate,
        HOUR,
        MIN,
        meridiem,
    ]);
    const overallStyle = (0, react_1.useMemo)(() => {
        if (open.date || open.month || open.year) {
            return { zIndex: 1 };
        }
        return {};
    }, [open.date, open.month, open.year]);
    return (react_1.default.createElement(Flex_1.default, { overrideStyle: overallStyle },
        react_1.default.createElement(react_native_1.TouchableOpacity, { testID: `calendarTestId_${placeholder}`, activeOpacity: 1, ref: Ref, onPress: handleDateOpen, disabled: disabled, style: styles.relative },
            react_1.default.createElement(Flex_1.default, { testID: "dateInputContainer", center: true, row: true, overrideStyle: dateInputStyle },
                react_1.default.createElement(Flex_1.default, { testID: "datePlaceHolder", flex: 1, start: true, end: true },
                    !(0, validators_1.isEmpty)(memoizedValue) ||
                        (!(0, validators_1.isEmpty)(placeholder) && (react_1.default.createElement(Text_1.default, { testID: "placeHolderText", size: 14, color: "gray" }, placeholder))),
                    react_1.default.createElement(Text_1.default, { size: 14 }, memoizedValue)),
                react_1.default.createElement(Flex_1.default, { middle: true, end: true, overrideStyle: { paddingLeft: 10 } },
                    react_1.default.createElement(SvgCalendar_1.default, null)))),
        open.date && (react_1.default.createElement(CalendarList_1.default, { ref: Ref, selectedDateColor: selectedDateColor, showTime: showTime, chosenDate: date, hour: hour, min: min, setDate: setDate, setHour: setHour, setMin: setMin, onChange: onChange, handleClose: handleDateClose, handleOpenMonth: handleOpenMonth, handleOpenYear: handleOpenYear, maxDate: maxDate, minDate: minDate, align: align, scrollable: scrollable })),
        open.month && (react_1.default.createElement(Month_1.default, { ref: Ref, handleSelectMonth: handleSelectMonth, align: align })),
        open.year && (react_1.default.createElement(Year_1.default, { ref: Ref, date: date, setDate: setDate, handleCloseYear: handleCloseYear, align: align }))));
};
Calendar.defaultProps = defaultProps;
exports.default = Calendar;
