"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_native_calendars_1 = require("react-native-calendars");
const react_native_1 = require("react-native");
const Flex_1 = __importDefault(require("../Flex/Flex"));
const SvgLeftAngle_1 = __importDefault(require("../icons/SvgLeftAngle"));
const SvgRightAngle_1 = __importDefault(require("../icons/SvgRightAngle"));
const Text_1 = __importDefault(require("../Text/Text"));
const colors_1 = require("../UikitUtils/colors");
const constants_1 = require("../UikitUtils/constants");
const CalendarHeader_1 = __importDefault(require("./CalendarHeader"));
const Calendar_1 = require("./Calendar");
const CalendarStyle_1 = require("./CalendarStyle");
const styles = react_native_1.StyleSheet.create({
    select: {
        borderRadius: 100,
        padding: 6,
        width: 32,
    },
    time: {
        padding: 16,
    },
    calendar: {
        borderWidth: 1,
        borderColor: colors_1.BORDER_COLOR,
        borderRadius: 4,
    },
    content: {
        paddingHorizontal: 32,
        paddingBottom: 6,
        backgroundColor: colors_1.WHITE,
    },
    innerContainer: {
        position: 'absolute',
        elevation: 10,
        width: '100%',
    },
    scrollable: {
        overflow: 'scroll',
    },
    containerOpen: {
        zIndex: constants_1.ZINDEX_MODAL,
    },
});
const renderArrow = (direction, selectedDateColor) => {
    if (direction === 'right') {
        return react_1.default.createElement(SvgRightAngle_1.default, { fill: selectedDateColor });
    }
    if (direction === 'left') {
        return react_1.default.createElement(SvgLeftAngle_1.default, { fill: selectedDateColor });
    }
    return react_1.default.createElement(react_1.default.Fragment, null);
};
const CURRENT_HOUR = new Date().getHours();
const CURRENT_MIN = new Date().getMinutes();
const CalendarList = ({ selectedDateColor, showTime, chosenDate, setDate, hour, setHour, min, setMin, onChange, handleOpenMonth, handleOpenYear, handleClose, maxDate, minDate, align, scrollable, }, ref) => {
    const dateStr = chosenDate ? chosenDate.dateString : '';
    const [markedDate, setMarkedDate] = (0, react_1.useState)(dateStr);
    const innerContainerStyle = (0, react_1.useMemo)(() => {
        const styleContainer = [];
        switch (align) {
            case 'topRight':
                styleContainer.push(styles.innerContainer);
                styleContainer.push(CalendarStyle_1.commonCalendarStyle.topRightContainer);
                break;
            case 'bottomLeft':
                styleContainer.push(styles.innerContainer);
                styleContainer.push(CalendarStyle_1.commonCalendarStyle.bottomContainer);
                break;
            default:
                styleContainer.push(styles.innerContainer);
                break;
        }
        if (scrollable) {
            styleContainer.push(styles.scrollable);
        }
        return react_native_1.StyleSheet.flatten(styleContainer);
    }, [align, scrollable]);
    (0, react_1.useEffect)(() => {
        if (dateStr) {
            setMarkedDate(dateStr);
        }
    }, [dateStr]);
    const HOURS = [];
    for (let i = 0; i < 24; i++) {
        if (i < 10)
            HOURS.push(`0${i}`);
        else
            HOURS.push(`${i}`);
    }
    const MINUTES = [];
    for (let i = 0; i < 60; i++) {
        if (i < 10)
            MINUTES.push(`0${i}`);
        else
            MINUTES.push(`${i}`);
    }
    const getRequiredDateString = (day, hr, minutes) => {
        let result = day;
        if (showTime) {
            if (hr === '' && minutes === '') {
                result += ' 00:00:00';
            }
            else if (hr !== '' && minutes === '') {
                result += ` ${hr}:00:00`;
            }
            else if (hr === '' && minutes !== '') {
                result += ` 00:${minutes}:00`;
            }
            else {
                result += ` ${hr}:${minutes}:00`;
            }
        }
        return result;
    };
    const handleDate = (day) => {
        setMarkedDate(day.dateString);
        setDate(day);
        const reqDate = getRequiredDateString(day.dateString, hour, min);
        onChange(reqDate);
        handleClose();
    };
    const handleColor = (item, index, time, selectedTime) => {
        let COLOR = 'primary';
        if (parseInt(item, 10) === time) {
            COLOR = 'link';
        }
        if (selectedTime === index) {
            COLOR = 'white';
        }
        if (parseInt(item, 10) === time && selectedTime === index) {
            COLOR = 'white';
        }
        return COLOR;
    };
    const handleHour = (cur_hour) => {
        const result = (0, Calendar_1.getAbsoluteTime)(cur_hour);
        setHour(result);
        if (!min) {
            setMin('00');
        }
        const reqDate = getRequiredDateString(dateStr, result, min);
        onChange(reqDate);
    };
    const handleMinute = (cur_min) => {
        const result = (0, Calendar_1.getAbsoluteTime)(cur_min);
        setMin(result);
        if (!hour) {
            setHour('00');
        }
        const reqDate = getRequiredDateString(dateStr, hour, result);
        onChange(reqDate);
    };
    const parsedHour = parseInt(hour, 10);
    const parsedMin = parseInt(min, 10);
    return (react_1.default.createElement(react_native_1.View, { ref: ref, testID: "calendarList" },
        react_1.default.createElement(Flex_1.default, { row: true, overrideStyle: innerContainerStyle, testID: "calendarListContainer" },
            react_1.default.createElement(react_1.default.Fragment, null,
                react_1.default.createElement(react_native_calendars_1.Calendar, { maxDate: maxDate, minDate: minDate, current: markedDate, onDayPress: handleDate, enableSwipeMonths: true, renderArrow: (direction) => renderArrow(direction, selectedDateColor), renderHeader: (currentDate) => (react_1.default.createElement(CalendarHeader_1.default, { date: currentDate, handleOpenMonth: handleOpenMonth, handleOpenYear: handleOpenYear })), markedDates: {
                        [markedDate]: {
                            selected: true,
                            selectedColor: selectedDateColor,
                        },
                    }, style: styles.calendar })),
            showTime && (react_1.default.createElement(Flex_1.default, { around: true, row: true, overrideStyle: [styles.calendar, styles.content] },
                react_1.default.createElement(Flex_1.default, { overrideStyle: { height: 346 } },
                    react_1.default.createElement(Text_1.default, { overrideStyle: styles.time, align: 'center', bold: true }, "Hour"),
                    react_1.default.createElement(react_native_1.ScrollView, { showsHorizontalScrollIndicator: false }, HOURS.map((item, index) => {
                        const color = handleColor(item, index, CURRENT_HOUR, parsedHour);
                        return (react_1.default.createElement(Flex_1.default, { key: item, center: true },
                            react_1.default.createElement(react_native_1.TouchableOpacity, { style: [
                                    styles.select,
                                    {
                                        backgroundColor: parsedHour === index ? selectedDateColor : '',
                                    },
                                ], onPress: () => handleHour(index) },
                                react_1.default.createElement(Text_1.default, { color: color, size: 16, align: 'center' }, item))));
                    }))),
                react_1.default.createElement(Flex_1.default, { overrideStyle: { height: 346 } },
                    react_1.default.createElement(Text_1.default, { overrideStyle: styles.time, align: 'center', bold: true }, "Min"),
                    react_1.default.createElement(react_native_1.ScrollView, { showsHorizontalScrollIndicator: false }, MINUTES.map((item, index) => {
                        const color = handleColor(item, index, CURRENT_MIN, parsedMin);
                        return (react_1.default.createElement(Flex_1.default, { key: item, center: true },
                            react_1.default.createElement(react_native_1.TouchableOpacity, { style: [
                                    styles.select,
                                    {
                                        backgroundColor: parsedMin === index ? selectedDateColor : '',
                                    },
                                ], onPress: () => handleMinute(index) },
                                react_1.default.createElement(Text_1.default, { color: color, size: 16, align: 'center' }, item))));
                    }))))))));
};
exports.default = react_1.default.forwardRef(CalendarList);
