"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const CalendarHeader_1 = require("./CalendarHeader");
const Text_1 = __importDefault(require("../Text/Text"));
const colors_1 = require("../UikitUtils/colors");
const CalendarStyle_1 = require("./CalendarStyle");
const styles = react_native_1.StyleSheet.create({
    monthContainer: {
        flexDirection: 'row',
        flexWrap: 'wrap',
        width: 260,
        position: 'absolute',
        zIndex: 1,
        backgroundColor: '#ffffff',
        borderWidth: 1,
        borderColor: colors_1.BORDER_COLOR,
        borderRadius: 4,
    },
    month: {
        padding: 8,
        width: '33.3333%',
        justifyContent: 'center',
        display: 'flex',
        flexDirection: 'column',
    },
});
const Month = ({ handleSelectMonth, align }, ref) => {
    const monthContainerStyle = (0, react_1.useMemo)(() => {
        switch (align) {
            case 'topRight':
                return react_native_1.StyleSheet.flatten([
                    styles.monthContainer,
                    CalendarStyle_1.commonCalendarStyle.topRightYearOrMonthContainer,
                ]);
            case 'bottomLeft':
                return react_native_1.StyleSheet.flatten([
                    styles.monthContainer,
                    CalendarStyle_1.commonCalendarStyle.bottomContainer,
                ]);
            default:
                return react_native_1.StyleSheet.flatten([
                    styles.monthContainer,
                    CalendarStyle_1.commonCalendarStyle.topContainer,
                ]);
        }
    }, []);
    return (react_1.default.createElement(react_native_1.View, { ref: ref, style: monthContainerStyle, testID: "monthContainer" }, CalendarHeader_1.MONTH.map((month, index) => (react_1.default.createElement(react_native_1.TouchableOpacity, { testID: `handleSelectMonthId${index}`, activeOpacity: 1, key: month, style: styles.month, onPress: (e) => handleSelectMonth(e, index) },
        react_1.default.createElement(Text_1.default, null, month))))));
};
exports.default = react_1.default.forwardRef(Month);
