"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.yearOptions = exports.MONTH_LIST = exports.currentDay = exports.dateString = exports.currentMonth = exports.currentYear = exports.getDateString = void 0;
const helpers_1 = require("../UikitUtils/helpers");
const getDateString = (timestamp) => {
    if ((0, helpers_1.isValidDate)(`${timestamp}`)) {
        const date = new Date(timestamp).getDate();
        const month = new Date(timestamp).getMonth() + 1;
        const year = new Date(timestamp).getFullYear();
        const formattedMonth = month < 10 ? `0${month}` : month;
        const formattedDate = date < 10 ? `0${date}` : date;
        return `${year}-${formattedMonth}-${formattedDate}`;
    }
    return '';
};
exports.getDateString = getDateString;
exports.currentYear = new Date().getFullYear();
exports.currentMonth = new Date().getMonth();
exports.dateString = (0, exports.getDateString)(new Date());
exports.currentDay = new Date().getDay();
exports.MONTH_LIST = [
    { label: 'January', value: 1 },
    { label: 'February', value: 2 },
    { label: 'March', value: 3 },
    { label: 'April', value: 4 },
    { label: 'May', value: 5 },
    { label: 'June', value: 6 },
    { label: 'July', value: 7 },
    { label: 'August', value: 8 },
    { label: 'September', value: 9 },
    { label: 'October', value: 10 },
    { label: 'November', value: 11 },
    { label: 'December', value: 12 },
];
const yearOptions = (startYear) => {
    const years = [];
    const initialYear = startYear || 2000;
    for (let i = initialYear; i <= exports.currentYear; i += 1) {
        years.unshift({ label: `${i}`, value: i });
    }
    return years;
};
exports.yearOptions = yearOptions;
