"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_native_1 = require("react-native");
const Flex_1 = __importDefault(require("../Flex/Flex"));
const Text_1 = __importDefault(require("../Text/Text"));
const colors_1 = require("../UikitUtils/colors");
const CalendarData_1 = require("./CalendarData");
const CalendarHelpers_1 = __importDefault(require("./CalendarHelpers"));
const uikitStyles = react_native_1.StyleSheet.create({
    container: {
        backgroundColor: colors_1.WHITE,
        borderTopLeftRadius: 10,
        borderTopRightRadius: 10,
    },
    title: {
        paddingVertical: 10,
    },
});
const MonthList = ({ getMonth, closeHandler, selectedMonth }) => {
    const setMonthHandler = (val) => {
        getMonth(val);
        closeHandler();
    };
    return (react_1.default.createElement(Flex_1.default, { overrideStyle: uikitStyles.container, center: true },
        react_1.default.createElement(Text_1.default, { bold: true, size: 18, overrideStyle: uikitStyles.title }, "Select Month"),
        react_1.default.createElement(CalendarHelpers_1.default, { dataSource: CalendarData_1.MONTH_LIST, selectHandler: setMonthHandler, selected: selectedMonth, numColumns: 3 })));
};
exports.default = MonthList;
