"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const Flex_1 = __importDefault(require("../Flex/Flex"));
const Text_1 = __importDefault(require("../Text/Text"));
const colors_1 = require("../UikitUtils/colors");
const CalendarData_1 = require("./CalendarData");
const CalendarHelpers_1 = __importDefault(require("./CalendarHelpers"));
const uikitStyles = react_native_1.StyleSheet.create({
    container: {
        backgroundColor: colors_1.WHITE,
        borderTopLeftRadius: 10,
        borderTopRightRadius: 10,
        maxHeight: '80%',
    },
    title: {
        paddingVertical: 10,
    },
});
const YearList = ({ getYear, closeHandler, selectedYear }) => {
    const setYearHandler = (val) => {
        getYear(val);
        closeHandler();
    };
    const years = (0, react_1.useMemo)(() => (0, CalendarData_1.yearOptions)(), []);
    return (react_1.default.createElement(Flex_1.default, { overrideStyle: uikitStyles.container, center: true },
        react_1.default.createElement(Text_1.default, { bold: true, size: 18, overrideStyle: uikitStyles.title }, "Select Year"),
        react_1.default.createElement(CalendarHelpers_1.default, { dataSource: years, selectHandler: setYearHandler, selected: selectedYear })));
};
exports.default = YearList;
