"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Playground = exports.Basic = void 0;
const react_1 = __importDefault(require("react"));
const react_native_1 = require("react-native");
const addon_actions_1 = require("@storybook/addon-actions");
const Card_1 = __importDefault(require("./Card"));
const Flex_1 = __importDefault(require("../Flex/Flex"));
const storiesHelper_1 = require("../UikitUtils/storiesHelper");
const styles = react_native_1.StyleSheet.create({
    box: {
        height: 100,
        width: 100,
    },
    flexStyle: {
        paddingHorizontal: '20%',
        paddingTop: 30,
    },
});
const Container = ({ title }) => (react_1.default.createElement(Flex_1.default, { center: true, middle: true, overrideStyle: styles.box },
    react_1.default.createElement(react_native_1.Text, null, title)));
const Basic = () => {
    return (react_1.default.createElement(react_native_1.ScrollView, null,
        react_1.default.createElement(Flex_1.default, { overrideStyle: styles.flexStyle },
            react_1.default.createElement(storiesHelper_1.CardComponent, { label: "primary" },
                react_1.default.createElement(Card_1.default, { onClick: (0, addon_actions_1.action)('clicked-primary') },
                    react_1.default.createElement(Container, { title: "primary" }))),
            react_1.default.createElement(storiesHelper_1.CardComponent, { label: "noDrop" },
                react_1.default.createElement(Card_1.default, { noDrop: true, onClick: (0, addon_actions_1.action)('clicked-noDrop') },
                    react_1.default.createElement(Container, { title: "noDrop" }))),
            react_1.default.createElement(storiesHelper_1.CardComponent, { label: "error" },
                react_1.default.createElement(Card_1.default, { type: "error", onClick: (0, addon_actions_1.action)('clicked-error') },
                    react_1.default.createElement(Container, { title: "error" }))),
            react_1.default.createElement(storiesHelper_1.CardComponent, { label: "success" },
                react_1.default.createElement(Card_1.default, { type: "success", onClick: (0, addon_actions_1.action)('clicked-success') },
                    react_1.default.createElement(Container, { title: "success" }))),
            react_1.default.createElement(storiesHelper_1.CardComponent, { label: "info" },
                react_1.default.createElement(Card_1.default, { type: "info", onClick: (0, addon_actions_1.action)('clicked-info') },
                    react_1.default.createElement(Container, { title: "info" }))))));
};
exports.Basic = Basic;
const Template = args => (react_1.default.createElement(Card_1.default, { ...args },
    react_1.default.createElement(Container, { title: "success" })));
exports.Playground = Template.bind({});
exports.default = {
    title: 'Components/Card',
    component: Card_1.default,
};
