"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const SvgCheckBox_1 = __importDefault(require("../icons/SvgCheckBox"));
const SvgCheckBoxOutline_1 = __importDefault(require("../icons/SvgCheckBoxOutline"));
const ThemeContext_1 = __importDefault(require("../ThemeContext/ThemeContext"));
const themeHelper_1 = require("../UikitUtils/themeHelper");
const validators_1 = require("../UikitUtils/validators");
const CheckboxLabel_1 = __importDefault(require("./CheckboxLabel"));
const defaultProps = {
    size: 24,
    name: '',
};
const styles = react_native_1.StyleSheet.create({
    container: {
        alignItems: 'center',
        flexDirection: 'row',
    },
});
const CheckBox = ({ color, size, onClick, checked, onBlur, label, labelColor, labelSize, name, value, testID, }) => {
    const { theme } = (0, react_1.useContext)(ThemeContext_1.default);
    const handleOnClick = (0, react_1.useCallback)((e) => {
        const isValuePresent = Array.isArray(value);
        if (typeof onClick === 'function') {
            if (!value) {
                e.target.value = [name];
            }
            else if (isValuePresent) {
                if (value.includes(name)) {
                    const filteredValue = value.filter(v => v !== name);
                    e.target.value = filteredValue;
                }
                else {
                    e.target.value = [...value, name];
                }
            }
            onClick(e);
        }
    }, [onClick]);
    let boxColor;
    if ((0, validators_1.isEmpty)(color)) {
        boxColor = (0, themeHelper_1.primaryColor)(theme);
    }
    else {
        boxColor = color;
    }
    return (react_1.default.createElement(react_native_1.TouchableOpacity, { testID: testID, onPress: handleOnClick, onBlur: onBlur, activeOpacity: 1, style: styles.container },
        checked ? (react_1.default.createElement(SvgCheckBox_1.default, { width: size, height: size, fill: boxColor })) : (react_1.default.createElement(SvgCheckBoxOutline_1.default, { width: size, height: size })),
        react_1.default.createElement(CheckboxLabel_1.default, { label: label, labelColor: labelColor, labelSize: labelSize })));
};
CheckBox.defaultProps = defaultProps;
exports.default = (0, react_1.memo)(CheckBox);
