"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const react_native_web_hooks_1 = require("react-native-web-hooks");
const Flex_1 = __importDefault(require("../Flex/Flex"));
const Text_1 = __importDefault(require("../Text/Text"));
const SvgClose_1 = __importDefault(require("../icons/SvgClose"));
const colors_1 = require("../UikitUtils/colors");
const styles = react_native_1.StyleSheet.create({
    chip: {
        borderRadius: 2,
        paddingVertical: 5.5,
        // height: 28,
        paddingRight: 12,
        alignSelf: 'flex-start',
    },
    borderOnHover: {
        borderLeftWidth: 4,
        paddingLeft: 8,
        paddingRight: 6,
    },
    borderOffHover: {
        borderLeftWidth: 2,
        paddingLeft: 10,
        paddingRight: 6,
    },
    noShowClose: {
        borderLeftWidth: 2,
        paddingLeft: 10,
        paddingRight: 12,
    },
    closeIcon: {
        marginLeft: 8,
    },
    closeIconHover: {
        paddingLeft: 8,
        opacity: 0.5,
    },
    error: {
        backgroundColor: colors_1.SEMANTIC_RED_TINT_2,
        borderLeftColor: colors_1.SEMANTIC_RED_DARK,
    },
    info: {
        backgroundColor: colors_1.SEMANTIC_INFO_BLUE_TINT_2,
        borderLeftColor: colors_1.SEMANTIC_INFO_BLUE_DARK,
    },
    success: {
        backgroundColor: colors_1.SEMANTIC_SUCCESS_GREEN_TINT_2,
        borderLeftColor: colors_1.SEMANTIC_SUCCESS_GREEN_DARK,
    },
    warning: {
        backgroundColor: colors_1.SEMANTIC_WARNING_ORANGE_TINT_2,
        borderLeftColor: colors_1.SEMANTIC_WARNING_ORANGE_DARK,
    },
    jungleGreen: {
        backgroundColor: colors_1.LABEL_JUNGLE_GREEN_TINT_2,
        borderLeftColor: colors_1.LABEL_JUNGLE_GREEN_PRIMARY,
    },
    kiwi: {
        backgroundColor: colors_1.LABEL_KIWI_TINT_2,
        borderLeftColor: colors_1.LABEL_KIWI_PRIMARY,
    },
    magenta: {
        backgroundColor: colors_1.LABEL_MAGENTA_TINT_2,
        borderLeftColor: colors_1.LABEL_MAGENTA_PRIMARY,
    },
    pink: {
        backgroundColor: colors_1.LABEL_PINK_TINT_2,
        borderLeftColor: colors_1.LABEL_PINK_PRIMARY,
    },
    turquoise: {
        backgroundColor: colors_1.LABEL_TURQUOISE_TINT_2,
        borderLeftColor: colors_1.LABEL_TURQUOISE_PRIMARY,
    },
    violet: {
        backgroundColor: colors_1.LABEL_VIOLET_TINT_2,
        borderLeftColor: colors_1.LABEL_VIOLET_PRIMARY,
    },
    yellow: {
        backgroundColor: colors_1.LABEL_YELLOW_TINT_2,
        borderLeftColor: colors_1.LABEL_YELLOW_PRIMARY,
    },
    icon: {
        paddingRight: 8,
    },
});
const getIconColor = (type) => {
    let color = colors_1.SEMANTIC_INFO_BLUE_DARK;
    if (type === 'error') {
        color = colors_1.SEMANTIC_RED_DARK;
    }
    else if (type === 'success') {
        color = colors_1.SEMANTIC_SUCCESS_GREEN_DARK;
    }
    else if (type === 'warning') {
        color = colors_1.SEMANTIC_WARNING_ORANGE_DARK;
    }
    return color;
};
const Chip = ({ message, type = 'success', onClose, color, icon }) => {
    const ref = (0, react_1.useRef)(null);
    const isHovered = (0, react_native_web_hooks_1.useHover)(ref);
    const showClose = typeof onClose === 'function';
    const styleArray = [styles.chip];
    if (color) {
        styleArray.push(styles[color]);
    }
    else {
        styleArray.push(styles[type]);
    }
    if (isHovered && showClose) {
        styleArray.push(styles.borderOnHover);
    }
    else if (!showClose) {
        styleArray.push(styles.noShowClose);
    }
    else {
        styleArray.push(styles.borderOffHover);
    }
    if (message) {
        return (react_1.default.createElement(react_native_1.View, { ref: ref },
            react_1.default.createElement(Flex_1.default, { row: true, center: true, overrideStyle: styleArray, testID: "chipOnhover" },
                icon && (react_1.default.createElement(Flex_1.default, { overrideStyle: styles.icon }, icon(14, 14, getIconColor(type)))),
                react_1.default.createElement(Text_1.default, { size: 14 }, message),
                showClose && (react_1.default.createElement(react_native_1.TouchableOpacity, { testID: "chipPress", onPress: () => onClose && onClose() }, isHovered ? (react_1.default.createElement(Flex_1.default, { middle: true, center: true, overrideStyle: styles.closeIconHover },
                    react_1.default.createElement(SvgClose_1.default, { width: 18, height: 18, fill: colors_1.GRAY_20 }))) : (react_1.default.createElement(Flex_1.default, { middle: true, center: true, overrideStyle: styles.closeIcon },
                    react_1.default.createElement(SvgClose_1.default, { width: 18, height: 18, fill: colors_1.GRAY_20 }))))))));
    }
    return react_1.default.createElement(react_native_1.View, { testID: "emptyView" });
};
exports.default = Chip;
