"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const Flex_1 = __importDefault(require("../Flex/Flex"));
const Text_1 = __importDefault(require("../Text/Text"));
const SvgRadioWithLine_1 = __importDefault(require("../icons/SvgRadioWithLine"));
const SvgRadioWithOutOutLine_1 = __importDefault(require("../icons/SvgRadioWithOutOutLine"));
const ThemeContext_1 = __importDefault(require("../ThemeContext/ThemeContext"));
const validators_1 = require("../UikitUtils/validators");
const themeHelper_1 = require("../UikitUtils/themeHelper");
const styles = react_native_1.StyleSheet.create({
    text: {
        marginLeft: 12,
    },
});
const defaultProps = {
    name: '',
};
const InputRadio = ({ onClick, onBlur, name, checked, size, color, label, labelSize, labelColor, value, disabled, }) => {
    const { theme } = (0, react_1.useContext)(ThemeContext_1.default);
    const currentValue = (0, react_1.useRef)(new react_native_1.Animated.Value(0)).current;
    const handleOnClick = (0, react_1.useCallback)((e) => {
        if (typeof onClick === 'function' && e && !disabled) {
            const requiredVal = typeof value !== 'undefined' ? value : name;
            e.target.value = requiredVal;
            onClick(e);
        }
    }, [onClick]);
    (0, react_1.useEffect)(() => {
        if (checked === true) {
            react_native_1.Animated.timing(currentValue, {
                toValue: 0.8,
                duration: 20,
                easing: react_native_1.Easing.in(react_native_1.Easing.bounce),
                useNativeDriver: false,
            }).start(() => {
                react_native_1.Animated.spring(currentValue, {
                    toValue: 1,
                    useNativeDriver: false,
                }).start();
            });
        }
    }, [checked]);
    let colors;
    if ((0, validators_1.isEmpty)(color)) {
        colors = (0, themeHelper_1.primaryColor)(theme);
    }
    else {
        colors = color;
    }
    return (react_1.default.createElement(react_native_1.TouchableOpacity, { testID: "InputRadio", onPress: handleOnClick, onBlur: onBlur, activeOpacity: 1 },
        react_1.default.createElement(Flex_1.default, { row: true, center: true },
            checked ? (react_1.default.createElement(react_native_1.Animated.View, { style: { transform: [{ scale: currentValue }] } },
                react_1.default.createElement(SvgRadioWithLine_1.default, { height: size, width: size, fill: colors }))) : (react_1.default.createElement(SvgRadioWithOutOutLine_1.default, { height: size, width: size })),
            react_1.default.createElement(Text_1.default, { testID: "label", size: labelSize, color: labelColor, overrideStyle: styles.text }, label))));
};
InputRadio.defaultProps = {
    labelSize: 14,
};
exports.default = InputRadio;
