"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isInputTextTypeKey = void 0;
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const SvgCloseSmall_1 = __importDefault(require("../icons/SvgCloseSmall"));
const Flex_1 = __importDefault(require("../Flex/Flex"));
const TextHelper_1 = require("../Text/TextHelper");
const ThemeContext_1 = __importDefault(require("../ThemeContext/ThemeContext"));
const colors_1 = require("../UikitUtils/colors");
const themeHelper_1 = require("../UikitUtils/themeHelper");
const Action_1 = __importDefault(require("./Action"));
const InputStyle_1 = require("./InputStyle");
const InputTextHelper_1 = require("./InputTextHelper");
const LabelWrapper_1 = __importDefault(require("./LabelWrapper"));
const ErrorMessage_1 = __importDefault(require("../ErrorMessage/ErrorMessage"));
const validators_1 = require("../UikitUtils/validators");
const isInputTextTypeKey = (str) => str !== undefined;
exports.isInputTextTypeKey = isInputTextTypeKey;
const defaultProps = {
    type: 'curved',
    align: 'left',
    size: 16,
    value: '',
    placeholderTextColor: colors_1.GRAY_70,
    minHeight: 44,
    color: 'primary',
    allowFontScaling: false,
    name: '',
    formikErrors: { '': '' },
    formikTouched: { '': false },
    error: false,
};
const InputText = ({ overrideStyle, onBlur, onFocus, required, label, type, autoFocus, value, placeholder, onChange, onChangeNative, actionLeft, actionRight, color, align, error, flex, disabled, bold, size, multiline, numberOfLines, onClear, onKeyPress, keyboardType, onSubmitEditing, returnKeyType, maxLength, secureTextEntry, placeholderTextColor, minHeight, getRef, textContentType, autoCapitalize, white, allowFontScaling, labelSize, labelColor, name, formikErrors, formikTouched, underlineColorAndroid }) => {
    const { theme } = (0, react_1.useContext)(ThemeContext_1.default);
    const ref = (0, react_1.useRef)(null);
    const textInput = (0, react_1.createRef)();
    const [containerStyle, setContainerStyle] = (0, react_1.useState)([]);
    const [textStyle, setTextStyle] = (0, react_1.useState)([]);
    const [actionLeftStyle, setActionLeftStyle] = (0, react_1.useState)([]);
    const [actionRightStyle, setActionRightStyle] = (0, react_1.useState)([]);
    const [isFocused, setIsFocused] = (0, react_1.useState)(false);
    const removeOutline = { outlineStyle: 'none' };
    (0, react_1.useEffect)(() => {
        handleContainerStyle();
    }, [error, disabled, overrideStyle]);
    (0, react_1.useEffect)(() => {
        if (typeof getRef === 'function' && textInput && textInput.current) {
            getRef(textInput);
        }
    }, []);
    const handleContainerStyle = () => {
        const containerStyleArray = [InputStyle_1.styles.relativestyle];
        const textStyleArray = [removeOutline];
        const actionLeftStyleArray = [];
        const actionRightStyleArray = [];
        (0, InputTextHelper_1.inputTypesHelper)({ theme, type, containerStyleArray });
        setContainerStyle(containerStyleArray);
        setTextStyle(textStyleArray);
        (0, InputTextHelper_1.inputActionHelper)({
            actionLeftStyleArray,
            actionRightStyleArray,
            type,
            theme,
        });
        (0, InputTextHelper_1.inputAlginHelper)(align, textStyleArray);
        (0, InputTextHelper_1.inputHelper)({
            theme,
            containerStyleArray,
            flex,
            error,
            overrideStyle,
            disabled,
            white,
        });
        (0, InputTextHelper_1.textStyleHelper)({
            theme,
            actionRight,
            actionLeft,
            textStyleArray,
            bold,
            size,
            disabled,
            type,
        });
        (0, InputTextHelper_1.minHeights)(minHeight, textStyleArray);
        const requiredColor = (0, TextHelper_1.textColorHelper)(theme, color);
        const textColorStyle = { color: requiredColor };
        textStyleArray.push(textColorStyle);
        setTextStyle(textStyleArray);
        setActionLeftStyle(actionLeftStyleArray);
        setActionRightStyle(actionRightStyleArray);
    };
    if (error && isFocused) {
        setIsFocused(false);
    }
    const handleClear = () => {
        if (onClear && typeof onChange === 'function') {
            onChange('');
        }
    };
    const handleFocus = (e) => {
        if (!error) {
            setIsFocused(true);
        }
        if (typeof onFocus === 'function') {
            onFocus(e);
        }
    };
    const handleBlur = (e) => {
        setIsFocused(false);
        if (typeof onBlur === 'function') {
            onBlur(e);
        }
    };
    const inputTextStyleObject = react_native_1.StyleSheet.flatten(textStyle);
    const focussedStyle = isFocused && !disabled ? { borderColor: (0, themeHelper_1.primaryColor)(theme) } : {};
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(LabelWrapper_1.default, { required: required, label: label, labelColor: labelColor, labelSize: labelSize, error: error },
            react_1.default.createElement(react_native_1.View, { ref: ref, style: [...containerStyle, focussedStyle] },
                react_1.default.createElement(react_native_1.View, { style: InputStyle_1.styles.containerActionStyle },
                    typeof actionLeft === 'function' && (react_1.default.createElement(Action_1.default, { action: actionLeft, actionStyle: actionLeftStyle })),
                    react_1.default.createElement(react_native_1.TextInput, { allowFontScaling: allowFontScaling, textContentType: textContentType, autoCapitalize: autoCapitalize, ref: textInput, keyboardType: keyboardType, multiline: multiline, style: inputTextStyleObject, onChangeText: onChange, onChange: onChangeNative, placeholder: placeholder, autoFocus: autoFocus, value: value, editable: !disabled, numberOfLines: numberOfLines, onBlur: handleBlur, onFocus: handleFocus, onKeyPress: onKeyPress, onSubmitEditing: onSubmitEditing, returnKeyType: returnKeyType, secureTextEntry: secureTextEntry, maxLength: maxLength, placeholderTextColor: placeholderTextColor, underlineColorAndroid: underlineColorAndroid }),
                    onClear && !disabled && (react_1.default.createElement(Flex_1.default, { overrideStyle: InputStyle_1.styles.enableClose },
                        react_1.default.createElement(react_native_1.TouchableOpacity, { onPress: handleClear },
                            react_1.default.createElement(SvgCloseSmall_1.default, null)))),
                    typeof actionRight === 'function' && (react_1.default.createElement(Action_1.default, { action: actionRight, actionStyle: actionRightStyle }))))),
        !(0, validators_1.isEmpty)(error) && (react_1.default.createElement(react_native_1.View, { style: InputStyle_1.styles.errorView },
            react_1.default.createElement(ErrorMessage_1.default, { name: name, touched: formikTouched, errors: formikErrors })))));
};
InputText.defaultProps = defaultProps;
exports.default = InputText;
