"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Playground = exports.Basic = void 0;
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const addon_actions_1 = require("@storybook/addon-actions");
const SvgDownAngle_1 = __importDefault(require("../icons/SvgDownAngle"));
const Button_1 = __importDefault(require("../Button/Button"));
const Flex_1 = __importDefault(require("../Flex/Flex"));
const storiesHelper_1 = require("../UikitUtils/storiesHelper");
const InputText_1 = __importDefault(require("./InputText"));
const multiLineValue = `Storybook extracts the component's description and renders it at the top of the page. It is automatically generated from the docgen component for the supported frameworks based on the component's source code. Below is an abridged example and available options.`;
const Basic = () => {
    const [value, setValue] = (0, react_1.useState)('');
    const [error, setError] = (0, react_1.useState)(false);
    const handleChange = (val) => {
        (0, addon_actions_1.action)('change')(val);
        setValue(val);
    };
    return (react_1.default.createElement(react_native_1.ScrollView, null,
        react_1.default.createElement(Flex_1.default, { overrideStyle: {
                paddingHorizontal: '20%',
                paddingTop: 30,
                paddingBottom: 40,
            } },
            react_1.default.createElement(Button_1.default, { onClick: () => setError(!error), overrideStyle: { marginVertical: 24 } }, "Set Error"),
            react_1.default.createElement(storiesHelper_1.InputTextComponent, { label: "Input AutoFocus" },
                react_1.default.createElement(InputText_1.default, { autoFocus: true, type: "curved", placeholder: "Input autoFocus", value: value, onChange: handleChange })),
            react_1.default.createElement(storiesHelper_1.InputTextComponent, { label: "Input Error" },
                react_1.default.createElement(InputText_1.default, { label: "Input Error", required: true, value: value, onChange: handleChange, error: error, placeholder: "Error" })),
            react_1.default.createElement(storiesHelper_1.InputTextComponent, { label: "Input Normal" },
                react_1.default.createElement(InputText_1.default, { error: error, type: "normal", value: value, onChange: handleChange })),
            react_1.default.createElement(storiesHelper_1.InputTextComponent, { label: "Input Normal Disabled" },
                react_1.default.createElement(InputText_1.default, { error: error, type: "normal", value: value, onChange: handleChange, disabled: true })),
            react_1.default.createElement(storiesHelper_1.InputTextComponent, { label: "Input curved " },
                react_1.default.createElement(InputText_1.default, { placeholder: "curved", value: value, onChange: handleChange })),
            react_1.default.createElement(storiesHelper_1.InputTextComponent, { label: "Input curved disabled" },
                react_1.default.createElement(InputText_1.default, { disabled: true, placeholder: "curved", value: value, onChange: handleChange })),
            react_1.default.createElement(storiesHelper_1.InputTextComponent, { label: "Input rounded" },
                react_1.default.createElement(InputText_1.default, { type: "rounded", placeholder: "rounded", value: value, onChange: handleChange })),
            react_1.default.createElement(storiesHelper_1.InputTextComponent, { label: "Input rounded disabled" },
                react_1.default.createElement(InputText_1.default, { disabled: true, type: "rounded", placeholder: "rounded", value: value, onChange: handleChange })),
            react_1.default.createElement(storiesHelper_1.InputTextComponent, { label: "Input noBorder " },
                react_1.default.createElement(InputText_1.default, { type: "noBorder", placeholder: "noBorder", value: value, onChange: handleChange })),
            react_1.default.createElement(storiesHelper_1.InputTextComponent, { label: "Input noBorder disabled" },
                react_1.default.createElement(InputText_1.default, { disabled: true, type: "noBorder", placeholder: "noBorder", value: value, onChange: handleChange })),
            react_1.default.createElement(storiesHelper_1.InputTextComponent, { label: "Input align center " },
                react_1.default.createElement(InputText_1.default, { align: "center", placeholder: "align center", value: value, onChange: handleChange })),
            react_1.default.createElement(storiesHelper_1.InputTextComponent, { label: "Input align left " },
                react_1.default.createElement(InputText_1.default, { align: "left", placeholder: "align left", value: value, onChange: handleChange })),
            react_1.default.createElement(storiesHelper_1.InputTextComponent, { label: "Input align right " },
                react_1.default.createElement(InputText_1.default, { align: "right", placeholder: "align right", value: value, onChange: handleChange })),
            react_1.default.createElement(storiesHelper_1.InputTextComponent, { label: "Input align top " },
                react_1.default.createElement(InputText_1.default, { align: "top", placeholder: "align top", value: value, onChange: handleChange })),
            react_1.default.createElement(storiesHelper_1.InputTextComponent, { label: "Input disabled" },
                react_1.default.createElement(InputText_1.default, { disabled: true, placeholder: "disabled", value: value, onChange: handleChange })),
            react_1.default.createElement(storiesHelper_1.InputTextComponent, { label: "Input text bold" },
                react_1.default.createElement(InputText_1.default, { bold: true, placeholder: "text bold", value: value, onChange: handleChange })),
            react_1.default.createElement(storiesHelper_1.InputTextComponent, { label: "Input label required" },
                react_1.default.createElement(InputText_1.default, { required: true, label: "label text required", placeholder: "label text required            ", value: value, onChange: handleChange })),
            react_1.default.createElement(storiesHelper_1.InputTextComponent, { label: "Input curved action" },
                react_1.default.createElement(InputText_1.default, { placeholder: "action", actionRight: () => react_1.default.createElement(SvgDownAngle_1.default, null), value: value, onChange: handleChange })),
            react_1.default.createElement(storiesHelper_1.InputTextComponent, { label: "Input curved actionLeft" },
                react_1.default.createElement(InputText_1.default, { placeholder: "actionLeft", actionLeft: () => react_1.default.createElement(SvgDownAngle_1.default, null), value: value, onChange: handleChange })),
            react_1.default.createElement(storiesHelper_1.InputTextComponent, { label: "Input normal action" },
                react_1.default.createElement(InputText_1.default, { type: "normal", placeholder: "action", actionRight: () => react_1.default.createElement(SvgDownAngle_1.default, null), value: value, onChange: handleChange })),
            react_1.default.createElement(storiesHelper_1.InputTextComponent, { label: "Input normal actionLeft" },
                react_1.default.createElement(InputText_1.default, { type: "normal", placeholder: "actionLeft", actionLeft: () => react_1.default.createElement(SvgDownAngle_1.default, null), value: value, onChange: handleChange })),
            react_1.default.createElement(storiesHelper_1.InputTextComponent, { label: "Input rounded action" },
                react_1.default.createElement(InputText_1.default, { type: "rounded", placeholder: "action", actionRight: () => react_1.default.createElement(SvgDownAngle_1.default, null), value: value, onChange: handleChange })),
            react_1.default.createElement(storiesHelper_1.InputTextComponent, { label: "Input rounded actionLeft" },
                react_1.default.createElement(InputText_1.default, { type: "rounded", placeholder: "actionLeft", actionLeft: () => react_1.default.createElement(SvgDownAngle_1.default, null), value: value, onChange: handleChange })),
            react_1.default.createElement(storiesHelper_1.InputTextComponent, { label: "Input normal action" },
                react_1.default.createElement(InputText_1.default, { type: "normal", actionRight: () => react_1.default.createElement(SvgDownAngle_1.default, null), value: value, onChange: handleChange })),
            react_1.default.createElement(storiesHelper_1.InputTextComponent, { label: "Input normal actionLeft" },
                react_1.default.createElement(InputText_1.default, { type: "normal", actionLeft: () => react_1.default.createElement(SvgDownAngle_1.default, null), value: value, onChange: handleChange })),
            react_1.default.createElement(storiesHelper_1.InputTextComponent, { label: "Input onClear" },
                react_1.default.createElement(InputText_1.default, { onClear: true, placeholder: "onClear", value: value, onChange: handleChange })),
            react_1.default.createElement(storiesHelper_1.InputTextComponent, { label: "Input size" },
                react_1.default.createElement(InputText_1.default, { size: 20, placeholder: "input size", value: value, onChange: handleChange })),
            react_1.default.createElement(storiesHelper_1.InputTextComponent, { label: "Input text color theme" },
                react_1.default.createElement(InputText_1.default, { color: "theme", placeholder: "Input text theme color", value: value, onChange: handleChange })),
            react_1.default.createElement(storiesHelper_1.InputTextComponent, { label: "Input text color black" },
                react_1.default.createElement(InputText_1.default, { color: "black", placeholder: "Input text black color", value: value, onChange: handleChange })),
            react_1.default.createElement(storiesHelper_1.InputTextComponent, { label: "Input text color error" },
                react_1.default.createElement(InputText_1.default, { color: "error", placeholder: "Input text error color", value: value, onChange: handleChange })),
            react_1.default.createElement(storiesHelper_1.InputTextComponent, { label: "Input text color gray" },
                react_1.default.createElement(InputText_1.default, { color: "gray", placeholder: "Input text gray color", value: value, onChange: handleChange })),
            react_1.default.createElement(storiesHelper_1.InputTextComponent, { label: "Input multiline" },
                react_1.default.createElement(InputText_1.default, { multiline: true, placeholder: "Input multiline", numberOfLines: 10, value: multiLineValue, onChange: (0, addon_actions_1.action)('multiline') })),
            react_1.default.createElement(storiesHelper_1.InputTextComponent, { label: "Input noraml multiline" },
                react_1.default.createElement(InputText_1.default, { align: "top", multiline: true, type: "normal", placeholder: "Input noraml multiline", numberOfLines: 10, value: multiLineValue, onChange: (0, addon_actions_1.action)('multiline') })))));
};
exports.Basic = Basic;
const Template = args => (react_1.default.createElement(InputText_1.default, { ...args }));
exports.Playground = Template.bind({});
exports.default = {
    title: 'Components/InputText',
    component: InputText_1.default,
};
