"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.minHeights = exports.textStyleHelper = exports.inputHelper = exports.inputAlginHelper = exports.inputActionHelper = exports.inputTypesHelper = void 0;
const textStyle_1 = require("../Text/textStyle");
const colors_1 = require("../UikitUtils/colors");
const InputStyle_1 = require("./InputStyle");
const InputText_1 = require("./InputText");
const inputTypesHelper = ({ type, containerStyleArray, }) => {
    if ((0, InputText_1.isInputTextTypeKey)(type)) {
        switch (type) {
            case 'normal':
                containerStyleArray.push(InputStyle_1.styles.normal);
                break;
            case 'curved':
                containerStyleArray.push(InputStyle_1.styles.curved);
                break;
            case 'rounded':
                containerStyleArray.push(InputStyle_1.styles.rounded);
                break;
            case 'noBorder':
                containerStyleArray.push(InputStyle_1.styles.noBorder);
                break;
            default:
                containerStyleArray.push(InputStyle_1.styles.curved);
                break;
        }
    }
};
exports.inputTypesHelper = inputTypesHelper;
const inputActionHelper = ({ actionLeftStyleArray, actionRightStyleArray, type, theme, }) => {
    switch (type) {
        case 'normal':
            actionLeftStyleArray.push(InputStyle_1.styles.leftAction);
            actionRightStyleArray.push(InputStyle_1.styles.rightAction);
            break;
        default:
            if (theme !== 'drug') {
                actionLeftStyleArray.push(InputStyle_1.styles.actionLeft);
            }
            actionRightStyleArray.push(InputStyle_1.styles.action);
            break;
    }
};
exports.inputActionHelper = inputActionHelper;
const inputAlginHelper = (align, textStyleArray) => {
    switch (align) {
        case 'center':
            textStyleArray.push(textStyle_1.styles.center);
            break;
        case 'right':
            textStyleArray.push(textStyle_1.styles.right);
            break;
        case 'top':
            textStyleArray.push(InputStyle_1.styles.textAlignVertical);
            break;
        default:
            textStyleArray.push(textStyle_1.styles.left);
            break;
    }
};
exports.inputAlginHelper = inputAlginHelper;
const inputHelper = ({ containerStyleArray, flex, error, overrideStyle, disabled, white, }) => {
    if (flex) {
        containerStyleArray.push({ flex });
    }
    if (error && !disabled) {
        containerStyleArray.push(InputStyle_1.styles.error);
    }
    if (disabled) {
        containerStyleArray.push(InputStyle_1.styles.disabled);
    }
    if (overrideStyle) {
        containerStyleArray.push(overrideStyle);
    }
    if (white) {
        containerStyleArray.push(InputStyle_1.styles.white);
    }
};
exports.inputHelper = inputHelper;
const textStyleHelper = ({ actionRight, actionLeft, textStyleArray, bold, size, disabled, type, }) => {
    if (typeof actionRight === 'function') {
        textStyleArray.push(InputStyle_1.styles.inputAction);
    }
    if (typeof actionLeft === 'function') {
        textStyleArray.push(InputStyle_1.styles.inputAction);
    }
    if (bold) {
        textStyleArray.push(textStyle_1.styles.bold);
    }
    if (disabled) {
        textStyleArray.push({ color: colors_1.GRAY_50 });
    }
    if (size) {
        textStyleArray.push({ fontSize: size });
    }
    if (type === 'normal') {
        textStyleArray.push(InputStyle_1.styles.normalCommon);
    }
    else {
        textStyleArray.push(InputStyle_1.styles.common);
    }
};
exports.textStyleHelper = textStyleHelper;
const minHeights = (minHeight, styleArray) => {
    if (typeof minHeight === 'number') {
        styleArray.push({ minHeight: minHeight });
    }
};
exports.minHeights = minHeights;
