"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const Text_1 = __importDefault(require("../Text/Text"));
const validators_1 = require("../UikitUtils/validators");
const styles = react_native_1.StyleSheet.create({
    labelContainer: {
        flexDirection: 'row',
    },
    required: {
        marginLeft: 4,
    },
    labelStyle: {
        marginBottom: 8,
    },
    labelStyleOne: {
        marginBottom: 0,
    },
});
const LabelWrapper = ({ required, children, label, labelSize, labelColor, error, }) => {
    const [style, setStyle] = (0, react_1.useState)();
    (0, react_1.useEffect)(() => {
        const styleArray = [styles.labelContainer];
        if ((0, validators_1.isEmpty)(label)) {
            styleArray.push(styles.labelStyleOne);
        }
        else {
            styleArray.push(styles.labelStyle);
        }
        setStyle(styleArray);
    }, [label]);
    const errorLabel = error ? 'error' : labelColor;
    const errorRequired = error ? 'error' : 'theme';
    return !(0, validators_1.isEmpty)(label) ? (react_1.default.createElement(react_native_1.View, null,
        react_1.default.createElement(react_native_1.View, { style: style },
            react_1.default.createElement(Text_1.default, { size: labelSize, color: errorLabel }, label),
            required && (react_1.default.createElement(Text_1.default, { size: labelSize, color: errorRequired, overrideStyle: styles.required }, "*"))),
        children)) : (react_1.default.createElement(react_1.default.Fragment, null, children));
};
exports.default = (0, react_1.memo)(LabelWrapper, (prevProps, nextProps) => prevProps.children === nextProps.children);
