"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.handleUpdatezIndex = void 0;
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const Flex_1 = __importDefault(require("../Flex/Flex"));
const colors_1 = require("../UikitUtils/colors");
const constants_1 = require("../UikitUtils/constants");
const Button_1 = __importDefault(require("../Button/Button"));
const SvgClose_1 = __importDefault(require("../icons/SvgClose"));
const ModalIcon_1 = __importDefault(require("./ModalIcon"));
const ThemeContext_1 = require("../ThemeContext/ThemeContext");
const Loader_1 = __importDefault(require("../Loader/Loader"));
const themeHelper_1 = require("../UikitUtils/themeHelper");
const { height } = react_native_1.Dimensions.get('window');
const uikitStyles = react_native_1.StyleSheet.create({
    close: {
        paddingTop: 20,
        paddingRight: 20,
        position: 'absolute',
        alignSelf: 'flex-end',
        zIndex: constants_1.ZINDEX_MODAL,
    },
    contentContainer: {
        backgroundColor: colors_1.WHITE,
        borderRadius: 4,
        position: 'relative',
    },
    flexContainer: {
        padding: 24,
    },
    flexMessage: {
        paddingTop: 20,
        paddingBottom: 40,
    },
    linkButton: {
        marginRight: 20,
    },
    secondaryButton: {
        marginRight: 20,
    },
    container: {
        justifyContent: 'center',
        alignItems: 'center',
        backgroundColor: 'rgba(0,0,0,0.25)',
        zIndex: 999,
        height,
    },
});
const handleUpdatezIndex = (node) => {
    const refNode = node;
    const clasnames = refNode?.getAttribute('class');
    if (!clasnames?.includes('navChildren') &&
        refNode &&
        refNode.tagName !== 'BODY') {
        refNode.style.zIndex = 'auto';
        const typedParentElement = refNode.parentNode;
        (0, exports.handleUpdatezIndex)(typedParentElement);
    }
};
exports.handleUpdatezIndex = handleUpdatezIndex;
const Modal = ({ open, children, onClose, disable, title, primaryAction, primaryActionHandler, secondaryAction, secondaryActionHandler, showClose, showIcon, iconSize, isLoading, animationType, }) => {
    const { theme } = (0, react_1.useContext)(ThemeContext_1.ThemeContext);
    const { PRIMARY_COLOR } = (0, themeHelper_1.getColors)(theme);
    return open ? (react_1.default.createElement(react_native_1.Modal, { animationType: animationType, transparent: true, visible: true, onRequestClose: onClose },
        react_1.default.createElement(react_native_1.TouchableWithoutFeedback, { disabled: disable, onPress: onClose },
            react_1.default.createElement(react_native_1.View, { style: uikitStyles.container },
                isLoading && react_1.default.createElement(Loader_1.default, null),
                children && !title && react_1.default.createElement(react_1.default.Fragment, null, children),
                title && children && (react_1.default.createElement(Flex_1.default, { overrideStyle: uikitStyles.contentContainer },
                    showClose && iconSize !== 'large' && (react_1.default.createElement(Flex_1.default, { overrideStyle: uikitStyles.close },
                        react_1.default.createElement(Button_1.default, { type: "link", onClick: onClose, testID: "closeModalIcon" },
                            react_1.default.createElement(SvgClose_1.default, { fill: colors_1.BLACK, width: 24, height: 24 })))),
                    react_1.default.createElement(Flex_1.default, { overrideStyle: uikitStyles.flexContainer },
                        react_1.default.createElement(ModalIcon_1.default, { title: title, showIcon: showIcon, iconSize: iconSize }),
                        react_1.default.createElement(Flex_1.default, { row: true, overrideStyle: uikitStyles.flexMessage, middle: iconSize === 'large' }, children),
                        react_1.default.createElement(Flex_1.default, { row: true, bottom: true, middle: iconSize === 'large' },
                            secondaryAction &&
                                (iconSize === 'large' ? (react_1.default.createElement(Button_1.default, { type: "secondary", onClick: secondaryActionHandler, overrideStyle: uikitStyles.secondaryButton }, secondaryAction)) : (!showClose && (react_1.default.createElement(Button_1.default, { type: "link", onClick: secondaryActionHandler, overrideStyle: uikitStyles.linkButton }, secondaryAction)))),
                            primaryAction && (react_1.default.createElement(Button_1.default, { flat: true, onClick: primaryActionHandler, overrideStyle: react_native_1.StyleSheet.flatten([
                                    { backgroundColor: PRIMARY_COLOR },
                                ]) }, primaryAction)))))))))) : null;
};
exports.default = (0, react_1.memo)(Modal, (prevProps, nextProps) => {
    if (nextProps.title &&
        prevProps.title &&
        prevProps.children &&
        nextProps.children) {
        return (prevProps.open === nextProps.open &&
            prevProps.title === nextProps.title &&
            prevProps.children === nextProps.children);
    }
    return prevProps.children === nextProps.children;
});
