import type { ReactNode } from 'react';
import type { TextStyle } from 'react-native';
import type { textColors } from '../Text/Text';
import type { DefaultPropTypes as selectDefaultProps, CommonPropType, list } from './SelectTag.types';
export type DefaultProps = {
    options: list[];
    size?: number;
    color?: textColors;
    bold?: boolean;
    searchPlaceHolder?: string;
} & selectDefaultProps;
export declare const defaultProps: DefaultProps;
type Props = {
    onChange: Function;
    handleClose: Function;
    renderOption?: (a: list) => ReactNode;
    overrideStyleOptionsItem?: TextStyle;
    resultItem: string;
    multiselect?: boolean;
    handleOnSelect?: (arg: string) => void;
    searchListTestId?: string;
} & typeof defaultProps & CommonPropType;
declare const SelectList: {
    ({ labelKey, options, onChange, handleClose, size, color, bold, renderOption, valueKey, overrideStyleOptionsItem, maxHeight, resultItem, search, searchBy, multiselect, handleOnSelect, searchListTestId, searchPlaceHolder, showsVerticalScrollIndicator, }: Props): JSX.Element;
    defaultProps: DefaultProps;
};
export default SelectList;
