"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.defaultProps = void 0;
/* eslint-env browser, node */
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const InputText_1 = __importDefault(require("../InputText/InputText"));
const constants_1 = require("../UikitUtils/constants");
const SelectList_1 = __importDefault(require("./SelectList"));
const ThemeContext_1 = __importDefault(require("../ThemeContext/ThemeContext"));
const colors_1 = require("../UikitUtils/colors");
const DropDownButton_1 = __importDefault(require("./DropDownButton"));
const helpers_1 = require("../UikitUtils/helpers");
const SelectListAnimation_1 = __importDefault(require("./SelectListAnimation"));
const SelectTagHelper_1 = require("./SelectTagHelper");
const LabelWrapper_1 = __importDefault(require("../InputText/LabelWrapper"));
const RenderMultiSelectInput_1 = __importDefault(require("./RenderMultiSelectInput"));
const validators_1 = require("../UikitUtils/validators");
const ErrorMessage_1 = __importDefault(require("../ErrorMessage/ErrorMessage"));
exports.defaultProps = {
    labelKey: 'label',
    options: [],
    valueKey: 'value',
    align: 'bottomLeft',
    maxHeight: 400,
    showsVerticalScrollIndicator: false,
    auto: true,
    name: '',
    formikErrors: { '': '' },
    formikTouched: { '': false },
    error: false,
};
const styles = react_native_1.StyleSheet.create({
    input: {
        zIndex: constants_1.ZINDEX_MODAL,
        justifyContent: 'center',
    },
    selectList: {
        position: 'absolute',
        zIndex: constants_1.ZINDEX_MODAL,
        width: '100%',
        borderWidth: 1,
        borderColor: colors_1.GRAY_95,
        borderRadius: 8,
        borderTopLeftRadius: 0,
        borderTopRightRadius: 0,
        overflow: 'hidden',
        shadowOffset: {
            width: 0,
            height: 0,
        },
        shadowOpacity: 0.16,
        shadowRadius: 16,
    },
    overAll: {
        position: 'relative',
        zIndex: 1,
    },
    bottomLeft: {
        left: 0,
        top: -40,
    },
    bottomRight: {
        right: 0,
        top: -40,
    },
    topLeft: {
        bottom: 80,
        left: 0,
    },
    overAllOne: {
        position: 'relative',
    },
    inputTagEnabled: {
        backgroundColor: colors_1.WHITE,
        borderStyle: 'solid',
    },
    inputTagDisabled: {
        borderStyle: 'dashed',
        backgroundColor: colors_1.GRAY_95,
    },
    inputTagContainer: {
        borderWidth: 1,
        borderRadius: 4,
        justifyContent: 'center',
        paddingRight: 8,
    },
    errorView: {
        marginTop: 3,
        zIndex: -1
    },
    error: {
        borderColor: colors_1.SEMANTIC_RED_PRIMARY,
        backgroundColor: colors_1.WHITE,
        borderStyle: 'solid',
    },
});
const SelectTag = ({ labelKey, options, onChange, value: initalValue, size, color, bold, inputColor = 'primary', renderOption, valueKey, iconColor, placeholder, overrideStyle, renderInput, align, overrideStyleOptionsItem, maxHeight, disabled, required, label, search, testID, searchBy, multiselect, searchListTestId, searchPlaceHolder, showsVerticalScrollIndicator, auto, labelSize, labelColor, name, formikErrors, formikTouched, error, }) => {
    const [selectListStyle, setSelectListStyle] = (0, react_1.useState)([
        styles.selectList,
    ]);
    const [selectAlign, setSelectAlign] = (0, react_1.useState)(align);
    const [selectOptions, setSelectOptions] = (0, react_1.useState)([]);
    const [resultItem, setResultItem] = (0, react_1.useState)('');
    const selectTagRef = react_1.default.useRef(null);
    const { ref, isComponentVisible, setIsComponentVisible } = (0, helpers_1.useComponentVisible)(false);
    const stringifyLabelKey = `${labelKey}`;
    const stringifyValueKey = `${valueKey}`;
    const themeContext = (0, react_1.useContext)(ThemeContext_1.default);
    const parentClicked = themeContext.parentClicked
        ? themeContext.parentClicked
        : false;
    const value = (0, react_1.useMemo)(() => multiselect && typeof initalValue === 'string'
        ? initalValue.split(',')
        : initalValue, [initalValue]);
    /**
     * add all your style logic here
     */
    let inputTagStyle;
    if (disabled) {
        inputTagStyle = styles.inputTagDisabled;
    }
    else {
        inputTagStyle = styles.inputTagEnabled;
    }
    if (error && !disabled) {
        inputTagStyle = styles.error;
    }
    const isCheckedOptions = Array.isArray(options)
        ? (0, react_1.useMemo)(() => (0, SelectTagHelper_1.checkedAppendFunction)({
            options,
            value,
            stringifyValueKey,
        }), [options])
        : [];
    const prefillValue = (0, react_1.useMemo)(() => (0, SelectTagHelper_1.handleDisplayValue)(isCheckedOptions, labelKey), [isCheckedOptions]);
    (0, react_1.useEffect)(() => {
        setSelectOptions(isCheckedOptions);
        setResultItem(prefillValue.toString());
    }, [options]);
    (0, react_1.useEffect)(() => {
        if (selectAlign === 'bottomLeft') {
            setSelectListStyle([styles.selectList, styles.bottomLeft]);
        }
        if (selectAlign === 'topLeft') {
            setSelectListStyle([styles.selectList, styles.topLeft]);
        }
        else {
            setSelectListStyle([styles.selectList, styles.bottomRight]);
        }
    }, [selectAlign]);
    (0, react_1.useEffect)(() => {
        if (parentClicked && isComponentVisible) {
            setIsComponentVisible(false);
            console.log('parentClicked: ', parentClicked);
        }
    }, [parentClicked]);
    const { labelArray: [result], } = (0, react_1.useMemo)(() => (0, SelectTagHelper_1.handleSelectedOption)({
        value,
        selectOptions,
        stringifyValueKey,
        stringifyLabelKey,
    }), [value, selectOptions]);
    const containerStyle = (0, react_1.useMemo)(() => {
        if (react_native_1.Platform.OS !== 'web') {
            return styles.overAllOne;
        }
        if (react_native_1.Platform.OS === 'web' && isComponentVisible) {
            return styles.overAll;
        }
        return styles.overAllOne;
    }, [isComponentVisible]);
    const handleOpen = (e) => {
        if (typeof Window !== 'undefined' &&
            auto &&
            selectTagRef &&
            selectTagRef.current) {
            selectTagRef.current.measureInWindow((_x, y, _w, h) => {
                if (y + h > window.innerHeight * 0.6) {
                    setSelectAlign('topLeft');
                }
                else {
                    setSelectAlign(align);
                }
            });
        }
        else {
            setSelectAlign('bottomLeft');
        }
        if (e) {
            e.stopPropagation();
        }
        if (themeContext.setParentClicked) {
            themeContext.setParentClicked(false);
        }
        setIsComponentVisible(true);
    };
    const handleClose = () => {
        setIsComponentVisible(false);
    };
    const toggleSelect = (e) => {
        if (e) {
            e.stopPropagation();
        }
        if (isComponentVisible) {
            handleClose();
        }
        else {
            handleOpen(e);
        }
    };
    const handleChangeSelectMultiSelect = (val) => {
        const { selectedOption, labelArray, valueArray } = (0, SelectTagHelper_1.handleSelectedOption)({
            value: val,
            selectOptions,
            stringifyValueKey,
            stringifyLabelKey,
        });
        setSelectOptions(selectedOption);
        setResultItem(labelArray.toString());
        onChange(valueArray);
    };
    const stringifiedValue = `${value}`;
    return (react_1.default.createElement(react_native_1.View, { style: containerStyle, ref: selectTagRef },
        react_1.default.createElement(react_native_1.TouchableOpacity, { testID: testID, ref: ref, disabled: disabled, onPress: toggleSelect, activeOpacity: 1 },
            react_1.default.createElement(react_native_1.View, { style: styles.input }, (() => {
                let resultTag;
                switch (multiselect) {
                    case true:
                        resultTag = (react_1.default.createElement(LabelWrapper_1.default, { label: label, required: required, labelColor: labelColor, labelSize: labelSize, error: error },
                            react_1.default.createElement(react_native_1.View, { style: [
                                    styles.inputTagContainer,
                                    {
                                        borderColor: error && !disabled
                                            ? colors_1.SEMANTIC_RED_PRIMARY
                                            : colors_1.BORDER_COLOR,
                                    },
                                ] },
                                react_1.default.createElement(DropDownButton_1.default, { spining: isComponentVisible, iconColor: iconColor, result: resultItem },
                                    react_1.default.createElement(RenderMultiSelectInput_1.default, { displayValue: resultItem, placeholder: placeholder })))));
                        break;
                    case undefined:
                    case false:
                        if (typeof renderInput === 'function') {
                            resultTag = (react_1.default.createElement(DropDownButton_1.default, { spining: isComponentVisible, iconColor: iconColor, result: stringifiedValue }, renderInput()));
                        }
                        if (typeof renderInput !== 'function') {
                            resultTag = (react_1.default.createElement(InputText_1.default, { error: error, labelColor: labelColor, labelSize: labelSize, label: label, required: required, overrideStyle: react_native_1.StyleSheet.flatten([
                                    inputTagStyle,
                                    overrideStyle,
                                ]), disabled: true, placeholder: placeholder, color: inputColor, value: result, type: "curved", size: size, actionRight: () => (react_1.default.createElement(DropDownButton_1.default, { result: stringifiedValue, spining: isComponentVisible, iconColor: iconColor })) }));
                        }
                        break;
                }
                return resultTag;
            })())),
        isComponentVisible && (react_1.default.createElement(SelectListAnimation_1.default, { isOpen: isComponentVisible },
            react_1.default.createElement(react_native_1.View, { style: selectListStyle, ref: ref, testID: "selectListWrapper" },
                react_1.default.createElement(SelectList_1.default, { searchPlaceHolder: searchPlaceHolder, searchListTestId: searchListTestId, overrideStyleOptionsItem: overrideStyleOptionsItem, valueKey: valueKey, renderOption: renderOption, bold: bold, size: size, color: color, labelKey: labelKey, options: selectOptions, onChange: onChange, handleClose: handleClose, maxHeight: maxHeight, resultItem: resultItem, search: search, searchBy: searchBy, multiselect: multiselect, handleOnSelect: handleChangeSelectMultiSelect, showsVerticalScrollIndicator: showsVerticalScrollIndicator })))),
        !(0, validators_1.isEmpty)(error) && (react_1.default.createElement(react_native_1.View, { style: styles.errorView },
            react_1.default.createElement(ErrorMessage_1.default, { name: name, touched: formikTouched, errors: formikErrors })))));
};
SelectTag.defaultProps = exports.defaultProps;
exports.default = (0, react_1.memo)(SelectTag);
