"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.disabled = exports.WithRenderOption = exports.WithMultiselect = exports.WithSearch = exports.Playground = void 0;
const react_1 = __importStar(require("react"));
const addon_actions_1 = require("@storybook/addon-actions");
const react_native_1 = require("react-native");
const SelectMock_1 = require("./SelectMock");
const SelectTag_1 = __importDefault(require("./SelectTag"));
const Text_1 = __importDefault(require("../Text/Text"));
const Flex_1 = __importDefault(require("../Flex/Flex"));
const colors_1 = require("../UikitUtils/colors");
const uikitStyles = react_native_1.StyleSheet.create({
    renderOptionStyles: {
        margin: 1,
        borderBottomWidth: 2,
        borderColor: colors_1.GRAY_90,
        padding: 2,
    },
});
const storyText = 'Select tag clicked';
const withMultiSelectLabel = 'SelectTag with Multi-Select';
const withMultiSelectPalceholder = 'Can select multiple options';
const withSearchLabel = 'SelectTag with Search';
const withSearchPlaceholder = "Can 'Search' through the options";
const disabledLabel = 'Disabled SelectTag';
const disabledPlaceholder = 'Disabled';
const withRenderOptionLabel = 'SelectTag with custom renderOption';
const withRenderOtionPlaceholder = 'Select any option..';
const commonArgs = {
    onChange: () => '',
    labelKey: 'label',
    valueKey: 'id',
    placeholder: 'Select Tag',
    options: SelectMock_1.DROPDOWN_DATA,
};
const Template = args => {
    const [value, setValue] = (0, react_1.useState)('');
    const changeHandler = (val) => {
        setValue(val);
        (0, addon_actions_1.action)(storyText)(val);
    };
    return react_1.default.createElement(SelectTag_1.default, { ...args, onChange: changeHandler, value: value });
};
exports.Playground = Template.bind({});
exports.Playground.args = {
    ...commonArgs,
    label: 'Playground SelectTag',
};
exports.WithSearch = Template.bind({});
exports.WithSearch.args = {
    ...commonArgs,
    label: withSearchLabel,
    placeholder: withSearchPlaceholder,
    search: true,
};
exports.WithMultiselect = Template.bind({});
exports.WithMultiselect.args = {
    ...commonArgs,
    label: withMultiSelectLabel,
    placeholder: withMultiSelectPalceholder,
    multiselect: true,
};
exports.WithRenderOption = Template.bind({});
exports.WithRenderOption.args = {
    ...commonArgs,
    label: withRenderOptionLabel,
    placeholder: withRenderOtionPlaceholder,
    renderOption(a) {
        return (react_1.default.createElement(Flex_1.default, { row: true, overrideStyle: uikitStyles.renderOptionStyles },
            react_1.default.createElement(Text_1.default, null, "Id of "),
            react_1.default.createElement(Text_1.default, { color: "theme" }, a.label),
            react_1.default.createElement(Text_1.default, null, " is "),
            react_1.default.createElement(Text_1.default, { color: "theme" },
                a.id,
                ".")));
    },
};
exports.disabled = Template.bind({});
exports.disabled.args = {
    ...commonArgs,
    label: disabledLabel,
    placeholder: disabledPlaceholder,
    disabled: true,
};
exports.default = {
    title: 'Components/SelectTag',
    component: SelectTag_1.default,
};
