import type { ReactNode } from 'react';
import type { TextStyle } from 'react-native';
import type { textColors } from '../Text/Text';
export type AlignType = 'bottomLeft' | 'bottomRight' | 'topLeft';
export type ViewStyle = import('react-native').ViewStyle;
export type list = {
    [key: string]: any;
};
export type DefaultPropTypes = {
    labelKey: string;
    options: list[];
    valueKey: string;
    align: AlignType;
    maxHeight: number;
    showsVerticalScrollIndicator: boolean;
    auto: boolean;
    name: string;
    formikErrors: {
        [key: string]: string | undefined;
    };
    formikTouched: {
        [key: string]: boolean | undefined;
    };
    error: boolean | any;
};
export type CommonPropType = {
    search?: boolean;
    searchBy?: string[];
    showsVerticalScrollIndicator?: boolean;
};
export type SelectTagValue = string | number | string[];
export type SelectProps = {
    onChange: Function;
    value: SelectTagValue;
    size?: number;
    color?: textColors;
    bold?: boolean;
    inputColor?: textColors;
    renderOption?: (a: list) => ReactNode;
    iconColor?: string;
    placeholder?: string;
    overrideStyle?: ViewStyle;
    renderInput?: () => ReactNode;
    overrideStyleOptionsItem?: TextStyle;
    isNavBar?: boolean;
    disabled?: boolean;
    required?: boolean;
    label?: string;
    testID?: string;
    multiselect?: boolean;
    searchListTestId?: string;
    searchPlaceHolder?: string;
    labelSize?: number;
    labelColor?: textColors;
} & DefaultPropTypes & CommonPropType;
export interface MultiOptionsEntity {
    [key: string]: string | boolean;
}
export interface OptionsEntity {
    [key: string]: string;
}
