"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.handleSelectedOption = exports.checkedAppendFunction = exports.handleMultiSelectArray = exports.handleDisplayValue = void 0;
const handleDisplayValue = (selectedOption, labelkey) => {
    const filteredValue = selectedOption.filter((option) => option.isChecked);
    return filteredValue.map((option) => {
        const opt = option;
        return opt[labelkey];
    });
};
exports.handleDisplayValue = handleDisplayValue;
const handleMultiSelectArray = ({ selectedOption, stringifyLabelKey, stringifyValueKey, }) => {
    const labelArray = (0, exports.handleDisplayValue)(selectedOption, stringifyLabelKey);
    const valueArray = (0, exports.handleDisplayValue)(selectedOption, stringifyValueKey);
    return {
        labelArray,
        valueArray,
    };
};
exports.handleMultiSelectArray = handleMultiSelectArray;
const checkedAppendFunction = ({ options, value, stringifyValueKey, }) => options.map((opt) => {
    if (Array.isArray(value) && value.includes(opt[stringifyValueKey])) {
        return { ...opt, isChecked: true };
    }
    return { ...opt, isChecked: false };
});
exports.checkedAppendFunction = checkedAppendFunction;
const handleSelectedOption = ({ value, selectOptions, stringifyValueKey, stringifyLabelKey, }) => {
    const selectedOption = selectOptions.map((option) => {
        if (`${value}` === `${option[stringifyValueKey]}` && !option.isChecked) {
            return { ...option, isChecked: true };
        }
        if (`${value}` === `${option[stringifyValueKey]}` && option.isChecked) {
            return { ...option, isChecked: false };
        }
        return { ...option };
    });
    const { labelArray, valueArray } = (0, exports.handleMultiSelectArray)({
        selectedOption,
        stringifyLabelKey,
        stringifyValueKey,
    });
    return {
        selectedOption,
        labelArray,
        valueArray,
    };
};
exports.handleSelectedOption = handleSelectedOption;
