"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const SvgClose_1 = __importDefault(require("../icons/SvgClose"));
const Flex_1 = __importDefault(require("../Flex/Flex"));
const Text_1 = __importDefault(require("../Text/Text"));
const colors_1 = require("../UikitUtils/colors");
const styles = react_native_1.StyleSheet.create({
    snackbar: {
        paddingHorizontal: 12,
        paddingVertical: 12,
    },
    error: {
        backgroundColor: colors_1.SEMANTIC_RED_PRIMARY,
    },
    info: {
        backgroundColor: colors_1.SEMANTIC_INFO_BLUE_PRIMARY,
    },
    success: {
        backgroundColor: colors_1.SEMANTIC_SUCCESS_GREEN_PRIMARY,
    },
    warning: {
        backgroundColor: colors_1.SEMANTIC_WARNING_ORANGE_PRIMARY,
    },
});
const SnackBar = ({ message, type, onClear }) => {
    const typedMessage = typeof message === 'string' ? message : '';
    const [showText, setShowText] = (0, react_1.useState)(true);
    (0, react_1.useEffect)(() => {
        if (!showText && typedMessage) {
            setShowText(true);
        }
    }, [typedMessage]);
    const styleArray = [styles.snackbar];
    if (type === 'error') {
        styleArray.push(styles.error);
    }
    else if (type === 'success') {
        styleArray.push(styles.success);
    }
    else if (type === 'warning') {
        styleArray.push(styles.warning);
    }
    else {
        styleArray.push(styles.info);
    }
    const hideSnackBar = () => {
        setShowText(false);
        if (typeof onClear === 'function') {
            onClear();
        }
    };
    return showText && typedMessage ? (react_1.default.createElement(Flex_1.default, { row: true, middle: true, between: true, overrideStyle: styleArray },
        react_1.default.createElement(Text_1.default, { color: "white" }, typedMessage),
        react_1.default.createElement(react_native_1.TouchableOpacity, { testID: "snackBarPress", onPress: hideSnackBar },
            react_1.default.createElement(Flex_1.default, { flex: 1, middle: true, center: true },
                react_1.default.createElement(SvgClose_1.default, { width: 16, height: 16 }))))) : (react_1.default.createElement(react_native_1.View, { testID: "emptyView" }));
};
exports.default = SnackBar;
