import React from 'react';
import { Styles } from './textStyle';
type TextStyle = import('react-native').TextStyle;
type ViewStyle = import('react-native').ViewStyle;
export type textColors = 'primary' | 'error' | 'link' | 'success' | 'white' | 'gray' | 'warning' | 'info' | 'black' | 'theme';
export type textTransForm = 'capitalize' | 'uppercase' | 'lowercase';
export type textAlignForm = 'left' | 'justify' | 'center' | 'right';
type DefaultProps = {
    size: number;
    color: textColors;
    align: textAlignForm;
    allowFontScaling: boolean;
};
declare const defaultProps: DefaultProps;
type Props = {
    children: import('react').ReactNode;
    bold?: boolean;
    italic?: boolean;
    underline?: boolean;
    overrideStyle?: ViewStyle | TextStyle | any;
    flex?: number;
    transform?: textTransForm;
    numberOfLines?: number;
    testID?: string;
    ellipsizeMode?: 'head' | 'middle' | 'tail' | 'clip';
} & typeof defaultProps;
export declare const isTextStyleKey: (str: string | undefined) => str is keyof Styles;
export declare const isTextColorKey: (str: string | undefined) => str is textColors;
declare const _default: React.MemoExoticComponent<{
    (props: Props): JSX.Element;
    defaultProps: DefaultProps;
}>;
export default _default;
