"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isTextColorKey = exports.isTextStyleKey = void 0;
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const ThemeContext_1 = __importDefault(require("../ThemeContext/ThemeContext"));
const TextHelper_1 = require("./TextHelper");
const textStyle_1 = require("./textStyle");
const defaultProps = {
    size: 16,
    align: 'left',
    color: 'primary',
    allowFontScaling: false,
};
const isTextStyleKey = (str) => str !== undefined;
exports.isTextStyleKey = isTextStyleKey;
const isTextColorKey = (str) => str !== undefined;
exports.isTextColorKey = isTextColorKey;
const Text = (props) => {
    const { theme } = (0, react_1.useContext)(ThemeContext_1.default);
    const { size, bold, italic, underline, transform, align, children, overrideStyle, color, flex, numberOfLines, testID, ellipsizeMode, allowFontScaling, } = props;
    const [styleContainer, setStyleContainer] = (0, react_1.useState)();
    (0, react_1.useEffect)(() => {
        handleStyleContainer();
    }, [bold, color, theme]);
    const handleStyleContainer = () => {
        let styleContainerArray = [];
        const textModifiedStyles = (0, TextHelper_1.textHelper)({
            color,
            flex,
            bold,
            italic,
            underline,
            transform,
            align,
        });
        styleContainerArray = [
            textStyle_1.styles.common,
            ...styleContainerArray,
            ...textModifiedStyles,
        ];
        const testColor = (0, TextHelper_1.textColorHelper)(theme, color);
        styleContainerArray.push({ color: testColor, fontSize: size });
        if (overrideStyle) {
            styleContainerArray.push(overrideStyle);
        }
        const computedStyle = react_native_1.StyleSheet.flatten(styleContainerArray);
        setStyleContainer(computedStyle);
    };
    return (react_1.default.createElement(react_native_1.Text, { ellipsizeMode: ellipsizeMode, testID: testID, style: styleContainer, numberOfLines: numberOfLines, allowFontScaling: allowFontScaling }, children));
};
Text.defaultProps = defaultProps;
exports.default = (0, react_1.memo)(Text);
