"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Basic = exports.Playground = void 0;
const react_1 = __importDefault(require("react"));
const react_native_1 = require("react-native");
const Flex_1 = __importDefault(require("../Flex/Flex"));
const Text_1 = __importDefault(require("./Text"));
const storiesHelper_1 = require("../UikitUtils/storiesHelper");
const { height } = react_native_1.Dimensions.get('screen');
const styles = react_native_1.StyleSheet.create({
    textStyle: {
        height,
    },
    flexStyle: {
        paddingTop: 30,
        paddingBottom: 5,
    },
});
exports.default = {
    title: 'Components/Text',
    component: Text_1.default,
};
const Template = (args) => (react_1.default.createElement(Text_1.default, { ...args }, "Text with dynamic size attribute"));
exports.Playground = Template.bind({});
const Basic = () => {
    return (react_1.default.createElement(react_native_1.ScrollView, { style: styles.textStyle },
        react_1.default.createElement(Flex_1.default, { overrideStyle: styles.flexStyle },
            react_1.default.createElement(storiesHelper_1.TextComponent, { label: "black" },
                react_1.default.createElement(Text_1.default, { color: "black" }, "text with color black")),
            react_1.default.createElement(storiesHelper_1.TextComponent, { label: "error" },
                react_1.default.createElement(Text_1.default, { color: "error" }, "text with color error")),
            react_1.default.createElement(storiesHelper_1.TextComponent, { label: "gray" },
                react_1.default.createElement(Text_1.default, { color: "gray" }, "text with color gray")),
            react_1.default.createElement(storiesHelper_1.TextComponent, { label: "info" },
                react_1.default.createElement(Text_1.default, { color: "info" }, "text with color info")),
            react_1.default.createElement(storiesHelper_1.TextComponent, { label: "link" },
                react_1.default.createElement(Text_1.default, { color: "link" }, "text with color link")),
            react_1.default.createElement(storiesHelper_1.TextComponent, { label: "primary" },
                react_1.default.createElement(Text_1.default, { color: "primary" }, "text with color primary")),
            react_1.default.createElement(storiesHelper_1.TextComponent, { label: "success" },
                react_1.default.createElement(Text_1.default, { color: "success" }, "text with color success")),
            react_1.default.createElement(storiesHelper_1.TextComponent, { label: "theme" },
                react_1.default.createElement(Text_1.default, { color: "theme" }, "text with color theme")),
            react_1.default.createElement(storiesHelper_1.TextComponent, { label: "warning" },
                react_1.default.createElement(Text_1.default, { color: "warning" }, "text with color warning")),
            react_1.default.createElement(storiesHelper_1.TextComponent, { label: "white" },
                react_1.default.createElement(react_native_1.View, { style: { backgroundColor: 'red' } },
                    react_1.default.createElement(Text_1.default, { color: "white" }, "text with color white"))))));
};
exports.Basic = Basic;
