"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.textColorHelper = exports.textHelper = void 0;
const colors_1 = require("../UikitUtils/colors");
const themeHelper_1 = require("../UikitUtils/themeHelper");
const Text_1 = require("./Text");
const textStyle_1 = require("./textStyle");
const textHelper = ({ color, flex, bold, italic, underline, transform, align, }) => {
    const styleArray = [];
    if (flex) {
        styleArray.push({ flex });
    }
    if (color === 'link') {
        styleArray.push(textStyle_1.styles.bold);
    }
    if (bold) {
        styleArray.push(textStyle_1.styles.bold);
    }
    if (italic) {
        styleArray.push(textStyle_1.styles.italic);
    }
    if (underline) {
        styleArray.push(textStyle_1.styles.underline);
    }
    if ((0, Text_1.isTextStyleKey)(transform)) {
        styleArray.push(textStyle_1.styles[transform]);
    }
    if ((0, Text_1.isTextStyleKey)(align)) {
        styleArray.push(textStyle_1.styles[align]);
    }
    return styleArray;
};
exports.textHelper = textHelper;
const textColorHelper = (theme, color) => {
    let textColor = '';
    if ((0, Text_1.isTextColorKey)(color)) {
        switch (color) {
            case 'primary':
                textColor = (0, themeHelper_1.primaryTextColor)(theme);
                break;
            case 'theme':
                textColor = (0, themeHelper_1.textThemeColor)(theme);
                break;
            case 'error':
                textColor = colors_1.SEMANTIC_RED_PRIMARY;
                break;
            case 'gray':
                textColor = colors_1.GRAY_60;
                break;
            case 'link':
                textColor = (0, themeHelper_1.linkTextColor)(theme);
                break;
            case 'info':
                textColor = colors_1.SEMANTIC_INFO_BLUE_PRIMARY;
                break;
            case 'black':
                textColor = colors_1.BLACK;
                break;
            case 'warning':
                textColor = colors_1.SEMANTIC_WARNING_ORANGE_PRIMARY;
                break;
            case 'white':
                textColor = colors_1.WHITE;
                break;
            case 'success':
                textColor = colors_1.SEMANTIC_SUCCESS_GREEN_PRIMARY;
                break;
            default:
                textColor = (0, themeHelper_1.primaryTextColor)(theme);
                break;
        }
    }
    return textColor;
};
exports.textColorHelper = textColorHelper;
