"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const Flex_1 = __importDefault(require("../Flex/Flex"));
const DEFAULT_DURATION = 5000;
const styles = react_native_1.StyleSheet.create({
    snackbar: {
        padding: 12,
    },
    error: {
        backgroundColor: 'red',
    },
    info: {
        backgroundColor: 'blue',
    },
});
const SnackBar = ({ message, type, theme, }) => {
    console.log('theme', theme);
    const styleArray = [styles.snackbar];
    if (type === 'ERROR') {
        styleArray.push(styles.error);
    }
    else if (type === 'SUCCESS') {
        styleArray.push({ backgroundColor: 'green' });
    }
    else if (type === 'INFO') {
        styleArray.push(styles.info);
    }
    else {
        styleArray.push({ backgroundColor: 'black' });
    }
    return (react_1.default.createElement(Flex_1.default, { testID: "snack", middle: true, overrideStyle: styleArray },
        react_1.default.createElement(react_native_1.Text, null, message)));
};
const ThemeWrapper = ({ children, type, duration, message, position, theme, }) => {
    const snackBarRef = (0, react_1.useRef)(null);
    const [isSnack, setSnack] = (0, react_1.useState)(false);
    const handleCloseSnack = () => {
        const timmerDuration = duration === 'SHORT' ? 2000 : 5000;
        snackBarRef.current = setTimeout(() => {
            setSnack(false);
        }, timmerDuration);
    };
    (0, react_1.useEffect)(() => {
        if (message) {
            setSnack(true);
            handleCloseSnack();
        }
        return () => {
            if (snackBarRef.current)
                clearInterval(snackBarRef.current);
        };
    }, [message]);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        isSnack && position === 'TOP' && (react_1.default.createElement(SnackBar, { message: message, type: type, theme: theme })),
        react_1.default.createElement(react_1.default.Fragment, null, children),
        isSnack && position === 'BOTTOM' && (react_1.default.createElement(SnackBar, { message: message, type: type, theme: theme }))));
};
ThemeWrapper.defaultProps = {
    type: 'BASIC',
    duration: DEFAULT_DURATION,
    position: 'BOTTOM',
};
exports.default = ThemeWrapper;
