"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.StyleGuide = void 0;
const react_1 = __importDefault(require("react"));
const react_native_1 = require("react-native");
const Flex_1 = __importDefault(require("../Flex/Flex"));
const Button_1 = __importDefault(require("../Button/Button"));
const Text_1 = __importDefault(require("../Text/Text"));
const constants_1 = require("../UikitUtils/constants");
const Toast_1 = __importDefault(require("./Toast"));
const styles = react_native_1.StyleSheet.create({
    box: {
        margin: 20,
    },
});
const StyleGuide = () => {
    const onCLickSuccessToast = () => {
        Toast_1.default.success({
            message: 'Single line Success  Toast',
            position: 'CENTER',
        });
    };
    const onCLickNeutralToast = () => {
        Toast_1.default.info({ message: 'Single line Neutral Toast', position: 'TOP' });
    };
    const onCLickWarningToast = () => {
        Toast_1.default.warning({ message: 'Single line Warning Toast', position: 'BOTTOM' });
    };
    const onCLickErrorToast = () => {
        Toast_1.default.danger({ message: 'Single line Error Toast ', position: 'CENTER' });
    };
    return (react_1.default.createElement(Flex_1.default, null,
        react_1.default.createElement(Flex_1.default, { column: true },
            react_1.default.createElement(Text_1.default, { overrideStyle: styles.box }, " Warning Toast (Default)"),
            react_1.default.createElement(Button_1.default, { type: "secondary", onClick: onCLickWarningToast }, "Click For Warning Toast")),
        react_1.default.createElement(Flex_1.default, { column: true },
            react_1.default.createElement(Text_1.default, { overrideStyle: styles.box }, "Success Toast (Position: center)"),
            react_1.default.createElement(Button_1.default, { type: "success", onClick: onCLickSuccessToast }, "Click For Success Toast")),
        react_1.default.createElement(Flex_1.default, { column: true },
            react_1.default.createElement(Text_1.default, { overrideStyle: styles.box }, " Neutral Toast (Position: left)"),
            react_1.default.createElement(Button_1.default, { onClick: onCLickNeutralToast }, "Click For Neutral Toast")),
        react_1.default.createElement(Flex_1.default, { column: true },
            react_1.default.createElement(Text_1.default, { overrideStyle: styles.box }, " Error Toast (Duration: long)"),
            react_1.default.createElement(Button_1.default, { type: "tertiary", onClick: onCLickErrorToast }, "Click For Error Toast"))));
};
exports.StyleGuide = StyleGuide;
exports.default = {
    title: `${constants_1.STORIES_PREFIX.components}/Toast`,
    component: Toast_1.default,
};
