"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const Text_1 = __importDefault(require("../Text/Text"));
const colors_1 = require("../UikitUtils/colors");
const constants_1 = require("../UikitUtils/constants");
const colors = {
    info: colors_1.SEMANTIC_INFO_BLUE_PRIMARY,
    success: colors_1.SEMANTIC_SUCCESS_GREEN_PRIMARY,
    danger: colors_1.SEMANTIC_RED_PRIMARY,
    warning: colors_1.SEMANTIC_WARNING_ORANGE_PRIMARY,
};
const styles = react_native_1.StyleSheet.create({
    overAll: {
        position: 'absolute',
        left: '4%',
        right: '4%',
        zIndex: 999,
        elevation: 1,
        borderRadius: 4,
    },
    top: {
        top: '4%',
    },
    center: {
        top: '50%',
    },
    bottom: {
        bottom: '4%',
    },
    textStyle: {
        padding: 14,
    },
});
const ToastBar = ({ insets }) => {
    const [messageType, setMessageType] = (0, react_1.useState)('success');
    const [message, setMessage] = (0, react_1.useState)(null);
    const [isPosition, setPosition] = (0, react_1.useState)('TOP');
    const [timeOutDuration, setTimeOutDuration] = (0, react_1.useState)(2500);
    const [isHide, setHide] = (0, react_1.useState)(false);
    const [isAnimationEnd, setAnimationEnd] = (0, react_1.useState)(false);
    let positionStyle;
    if (isPosition === 'TOP') {
        positionStyle = { top: insets.top };
    }
    else if (isPosition === 'CENTER') {
        positionStyle = styles.center;
    }
    else {
        positionStyle = { bottom: insets.bottom };
    }
    const timeOutRef = (0, react_1.useRef)(null);
    const onNewToast = (data) => {
        setAnimationEnd(true);
        setHide(true);
        setMessage(data.message);
        setMessageType(data.type);
        if (data.duration === 'LONG') {
            setTimeOutDuration(2000);
        }
        else {
            setTimeOutDuration(1000);
        }
        if (data.position) {
            setPosition(data.position);
        }
    };
    const closeToast = (0, react_1.useCallback)(() => {
        setHide(false);
        setTimeOutDuration(timeOutDuration);
        clearInterval(timeOutRef.current);
    }, []);
    (0, react_1.useEffect)(() => {
        if (message) {
            timeOutRef.current = setInterval(() => {
                if (timeOutDuration < 0) {
                    closeToast();
                }
                else {
                    setTimeOutDuration(prev => prev - 1000);
                }
            }, 1000);
        }
        return () => {
            clearInterval(timeOutRef.current);
        };
    }, [closeToast, message, timeOutDuration]);
    (0, react_1.useEffect)(() => {
        react_native_1.DeviceEventEmitter.addListener(constants_1.SHOW_TOAST_MESSAGE, onNewToast);
        return () => {
            react_native_1.DeviceEventEmitter.removeAllListeners();
        };
    }, []);
    if (!isAnimationEnd) {
        return null;
    }
    return isHide ? (react_1.default.createElement(react_native_1.View, { style: [
            {
                backgroundColor: colors[messageType],
            },
            styles.overAll,
            positionStyle,
        ] },
        react_1.default.createElement(react_native_1.TouchableOpacity, { onPress: closeToast },
            react_1.default.createElement(Text_1.default, { size: 16, align: "center", color: "white", overrideStyle: styles.textStyle }, message)))) : (react_1.default.createElement(react_1.default.Fragment, null));
};
ToastBar.defaultProps = {
    insets: {
        top: '4%',
        bottom: '4%',
    },
};
exports.default = ToastBar;
