/// <reference types="react" />
import { ThemeType } from './themeTypes';
export declare const getTheme: () => ThemeType;
export declare const convertCurrencyFormat: (value: string | number) => string;
export declare const isValidDate: (date: string) => boolean;
export declare const useComponentVisible: (initialIsVisible: boolean) => {
    ref: import("react").RefObject<any>;
    isComponentVisible: boolean;
    setIsComponentVisible: import("react").Dispatch<import("react").SetStateAction<boolean>>;
};
export declare const removeUnderScores: (status: string) => string;
export declare const resolveObj: (obj: any, path: string) => string;
export declare const openNewWindowHelper: (url: string) => void;
export declare const dateFormatter: (timestamp: string) => string;
export declare const useStateCallback: (initialState: any) => any[];
type GetParamsObject = {
    [key: string]: any;
};
type GetParamsPath = string;
export declare const get: (obj: GetParamsObject, path: GetParamsPath) => any;
export declare const errorHandler: (response: any) => never;
export type DateType = 'Do MMM YYYY' | 'DD-MMM-YYYY' | 'HH:mm' | 'HH' | 'mm' | 'DD/MM/YYYY HH:mm:ss' | 'DD-MM-YYYY';
/**
 * Return the requested date format
 * @param value Date string or object
 * @param format returns the specified date format
 * @param isUnix converts to unix and returns unix formatted date
 * @param convertToLocal converts and returns to local timezone
 */
export declare const getDateString: (value: string | number | Object | undefined, format: DateType, isUnix?: boolean, convertToLocal?: boolean) => string;
export declare const codeToArray: (code?: string) => string[];
export declare const isAutoFillSupported: boolean;
export {};
