"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CardComponent = exports.InputTextComponent = exports.TextComponent = exports.ButtonComponent = void 0;
const react_1 = __importDefault(require("react"));
const react_native_1 = require("react-native");
const Flex_1 = __importDefault(require("../Flex/Flex"));
const Text_1 = __importDefault(require("../Text/Text"));
const colors_1 = require("./colors");
// import { removeUnderScores } from './helpers';
const styles = react_native_1.StyleSheet.create({
    label: {
        paddingVertical: 16,
    },
    colorBox: {
        height: 70,
        width: 70,
        borderRadius: 4,
        borderColor: colors_1.BLACK,
        borderWidth: 1,
    },
    colorLabel: {
        paddingLeft: 16,
        width: 250,
    },
    colorContainer: {
        padding: 24,
    },
    overAll: {
        paddingHorizontal: '10%',
    },
});
const ButtonComponent = ({ label, children }) => (react_1.default.createElement(react_native_1.View, { testID: "ButtonComponent", style: styles.overAll },
    react_1.default.createElement(Text_1.default, { testID: "buttonText", transform: "capitalize", size: 16, bold: true, color: "info", overrideStyle: styles.label },
        label,
        ":"),
    children));
exports.ButtonComponent = ButtonComponent;
// export const ColorComponent = ({ lable, color, colorCodeLabel }) => (
//   <Flex row overrideStyle={styles.colorContainer}>
//     <View
//       testID="ColorComponent"
//       style={[styles.colorBox, { backgroundColor: color }]}
//     />
//     <Flex between overrideStyle={styles.colorLabel}>
//       <Text color="black" transform="capitalize">
//         {removeUnderScores(lable)}
// :
// </Text>
//       <Text color="gray" italic>
//         {colorCodeLabel}
//       </Text>
//     </Flex>
//   </Flex>
// );
const TextComponent = ({ label, children }) => (react_1.default.createElement(react_native_1.View, { style: styles.overAll, testID: "TextComponent" },
    react_1.default.createElement(Text_1.default, { testID: "text", transform: "capitalize", color: "info", bold: true, size: 20, overrideStyle: styles.label },
        label,
        ":"),
    children));
exports.TextComponent = TextComponent;
const InputTextComponent = ({ label, children }) => (react_1.default.createElement(Flex_1.default, null,
    react_1.default.createElement(Text_1.default, { color: "theme", size: 16, bold: true, transform: "capitalize", overrideStyle: styles.label },
        label,
        ":"),
    children));
exports.InputTextComponent = InputTextComponent;
const CardComponent = ({ label, children }) => (react_1.default.createElement(Flex_1.default, null,
    react_1.default.createElement(Text_1.default, { color: "info", size: 16, bold: true, transform: "capitalize", overrideStyle: styles.label },
        label,
        ":"),
    children));
exports.CardComponent = CardComponent;
// export const StatusComponent = ({ label, children }) => (
//   <Flex>
//     <Text
//       size={20}
//       color="info"
//       bold
//       transform="capitalize"
//       overrideStyle={styles.label}
//     >
//       {label}
// :
// </Text>
//     {children}
//   </Flex>
// );
