import { ThemeType } from './themeTypes';
export declare const primaryDarkColor: (theme: ThemeType) => "#5173fe" | "#191A3E" | "#00347C";
export declare const primaryColor: (theme: ThemeType) => "#5168FF" | "#232559" | "#0046A0";
export declare const primaryTint1Color: (theme: ThemeType) => "#2BAED5" | "#4F517A" | "#448AFF";
export declare const primaryTint2Color: (theme: ThemeType) => "#519ef9" | "#7B7C9B" | "#95C3FF";
export declare const primaryTint3Color: (theme: ThemeType) => "#B5DBFF" | "#A7A8BD" | "#CCE2FF";
export declare const primaryTint4Color: (theme: ThemeType) => "#b5dbff" | "#F9F9F9" | "#F2F8FF";
export declare const secondaryDarkColor: (theme: ThemeType) => "#00C853" | "#A93E1D";
export declare const secondaryColor: (theme: ThemeType) => "#E73785" | "#F25929" | "#32FF14";
export declare const secondaryTint1Color: (theme: ThemeType) => "#80FF6D" | "#F57A54";
export declare const secondaryTint2Color: (theme: ThemeType) => "#97FF88" | "#F79B7F";
export declare const secondaryTint3Color: (theme: ThemeType) => "#D3FFCC" | "#FABDA9";
export declare const secondaryTint4Color: (theme: ThemeType) => "#E9FFE5" | "#FEEEEA";
export declare const primaryButtonColor: (theme: ThemeType) => "#0046A0" | "#2BAED5" | "#f25929";
export declare const primaryButtonTextColor: (theme: ThemeType) => "white" | "primary";
export declare const secondaryButtonTextColor: (theme: ThemeType) => "primary" | "theme";
export declare const defaultButtonCurved: (theme: ThemeType) => boolean;
export declare const primaryTextColor: (theme: ThemeType) => string;
export declare const textThemeColor: (theme: ThemeType) => "#0046A0" | "#2BAED5" | "#f25929";
export declare const linkTextColor: (theme: ThemeType) => "#2BAED5" | "#4F517A" | "#448AFF" | "#00529C";
export declare const curvedDefaultInputHelper: (theme: ThemeType) => boolean;
export declare const getColors: (theme: ThemeType) => {
    PRIMARY_DARK_COLOR: string;
    PRIMARY_COLOR: string;
    PRIMARY_TINT_1_COLOR: string;
    PRIMARY_TINT_2_COLOR: string;
    PRIMARY_TINT_3_COLOR: string;
    PRIMARY_TINT_4_COLOR: string;
    SECONDARY_DARK_COLOR: string;
    SECONDARY_COLOR: string;
    SECONDARY_TINT_1_COLOR: string;
    SECONDARY_TINT_2_COLOR: string;
    SECONDARY_TINT_3_COLOR: string;
    SECONDARY_TINT_4_COLOR: string;
    PRIMARY_TEXT_COLOR: string;
    THEME_TEXT_COLOR: string;
    PRIMARY_BUTTON_TEXT_COLOR: string;
    SECONDARY_BUTTON_TEXT_COLOR: string;
    LINK_TEXT_COLOR: string;
    BLACK: "#000000";
    WHITE: "#FFFFFF";
    GRAY_10: "#1A1A1A";
    GRAY_20: "#333333";
    GRAY_30: "#4D4D4D";
    GRAY_40: "#666666";
    GRAY_50: "#808080";
    GRAY_60: "#999999";
    GRAY_70: "#B3B3B3";
    GRAY_80: "#CCCCCC";
    GRAY_90: "#E6E6E6";
    GRAY_95: "#F6F6F6";
    BORDER_COLOR: "#CCCCCC";
    SEMANTIC_SUCCESS_GREEN_DARK: "#2d9c6d";
    SEMANTIC_SUCCESS_GREEN_PRIMARY: "#18c081";
    SEMANTIC_SUCCESS_GREEN_TINT_1: "#74d9b3";
    SEMANTIC_SUCCESS_GREEN_TINT_2: "#d7f8e9";
    SEMANTIC_RED_DARK: "#d74242";
    SEMANTIC_RED_PRIMARY: "#f94949";
    SEMANTIC_RED_TINT_1: "#fca4a4";
    SEMANTIC_RED_TINT_2: "#feeadf";
    SEMANTIC_INFO_BLUE_DARK: "#066ecf";
    SEMANTIC_INFO_BLUE_PRIMARY: "#1890ff";
    SEMANTIC_INFO_BLUE_TINT_2: "#e6f2fd";
    SEMANTIC_INFO_BLUE_TINT_1: "#8cc8ff";
    SEMANTIC_WARNING_ORANGE_DARK: "#de8024";
    SEMANTIC_WARNING_ORANGE_PRIMARY: "#ff991a";
    SEMANTIC_WARNING_ORANGE_TINT_1: "#ffcc8d";
    SEMANTIC_WARNING_ORANGE_TINT_2: "#fff1e0";
    LABEL_JUNGLE_GREEN_PRIMARY: "#25959A";
    LABEL_JUNGLE_GREEN_TINT_1: "#66B5B8";
    LABEL_JUNGLE_GREEN_TINT_2: "#D3EAEB";
    LABEL_VIOLET_PRIMARY: "#7767E5";
    LABEL_VIOLET_TINT_1: "#9D90F9";
    LABEL_VIOLET_TINT_2: "#E7E3FF";
    LABEL_TURQUOISE_PRIMARY: "#05C2CF";
    LABEL_TURQUOISE_TINT_1: "#69DAE2";
    LABEL_TURQUOISE_TINT_2: "#C1F8FC";
    LABEL_MAGENTA_PRIMARY: "#C038CC";
    LABEL_MAGENTA_TINT_1: "#D988E0";
    LABEL_MAGENTA_TINT_2: "#F2D7F5";
    LABEL_PINK_PRIMARY: "#FF57A2";
    LABEL_PINK_TINT_1: "#FF9AC7";
    LABEL_PINK_TINT_2: "#FFDBEB";
    LABEL_KIWI_PRIMARY: "#8ACE46";
    LABEL_KIWI_TINT_1: "#B9E290";
    LABEL_KIWI_TINT_2: "#EAFADA";
    LABEL_YELLOW_PRIMARY: "#DFBF00";
    LABEL_YELLOW_TINT_1: "#EFDF80";
    LABEL_YELLOW_TINT_2: "#F9F2CC";
};
