"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isValidEmail = exports.isNumber = exports.secureImage = exports.isEmpty = void 0;
const react_native_1 = require("react-native");
const isEmpty = (value) => value === undefined || value === null || value === '';
exports.isEmpty = isEmpty;
const secureImage = (imageUrl) => {
    if ((0, exports.isEmpty)(imageUrl)) {
        return '';
    }
    if (react_native_1.Platform.OS === 'web') {
        return imageUrl.replace(/(http:\/\/)/, '//').replace(/\s/g, '%20');
    }
    return imageUrl.replace(/(http:\/\/)/, 'https://').replace(/\s/g, '%20');
};
exports.secureImage = secureImage;
const isNumber = (value) => {
    if (typeof value === 'string' || typeof value === 'number') {
        return value.toString().match(/^\d*$/) !== null;
    }
    return false;
};
exports.isNumber = isNumber;
const isValidEmail = (value) => {
    if (typeof value === 'string') {
        return (value
            .trim()
            .match(/^([a-zA-Z0-9_\-\.]+)@([a-zA-Z0-9_\-\.]+)\.([a-zA-Z]{2,5})$/) !==
            null);
    }
    return false;
};
exports.isValidEmail = isValidEmail;
